/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.40 from the
 * contents of URPM.xs. Do not edit this file, edit URPM.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "URPM.xs"
/* Copyright (c) 2002, 2003, 2004, 2005 MandrakeSoft SA
 * Copyright (c) 2005, 2006, 2007, 2008 Mandriva SA
 * Copyright (c) 2011-2016 Mageia
 *
 * All rights reserved.
 * This program is free software; you can redistribute it and/or
 * modify it under the same terms as Perl itself.
 *
 * 
 */
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "rpmversion.h"

#include <sys/utsname.h>
#include <sys/select.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <unistd.h>
#include <libintl.h>

// fix compiling (error: conflicting types for ‘fflush’):
#undef Fflush
#undef Mkdir
#undef Stat
#undef Fstat

static inline void *_free(const void * p) {
  if (p != NULL) free((void *)p); 
  return NULL;
}
typedef struct rpmSpec_s * Spec;

#include <rpm/rpmio.h>
#include <rpm/rpmdb.h>
#include <rpm/rpmts.h>
#include <rpm/rpmte.h>
#include <rpm/rpmps.h>
#include <rpm/rpmpgp.h>
#include <rpm/rpmcli.h>
#include <rpm/rpmbuild.h>
#include <rpm/rpmlog.h>

struct s_Package {
  Header h;
  UV filesize;
  unsigned flag;
  char *info;
  char *requires;
  char *recommends;
  char *obsoletes;
  char *conflicts;
  char *provides;
  char *rflags;
  char *summary;
};

struct s_Transaction {
  rpmts ts;
  int count;
};

struct s_TransactionData {
  SV* callback_open;
  SV* callback_close;
  SV* callback_trans;
  SV* callback_uninst;
  SV* callback_inst;
  SV* callback_error;
  SV* callback_elem;
  SV* callback_verify;
  long min_delta;
  SV *data; /* chain with another data user provided */
};

typedef struct s_Transaction* URPM__DB;
typedef struct s_Transaction* URPM__Transaction;
typedef struct s_Package* URPM__Package;

/*
 * URPM__Package->flag is an unsigned int:
 * bit :  significance
 * 0..20: ID
 * 21-23: rate
 * 24:    BASE
 * 25:    SKIP
 * 26:    DISABLE_OBSOLETE
 * 27:    INSTALLED
 * 28:    REQUESTED
 * 29:    REQUIRED
 * 30:    UPGRADE
 * 31:    NO_HEADER_FREE
 * */

#define FLAG_ID_MASK          0x001fffffU
#define FLAG_RATE_MASK        0x00e00000U
#define FLAG_BASE             0x01000000U
#define FLAG_SKIP             0x02000000U
#define FLAG_DISABLE_OBSOLETE 0x04000000U
#define FLAG_INSTALLED        0x08000000U
#define FLAG_REQUESTED        0x10000000U
#define FLAG_REQUIRED         0x20000000U
#define FLAG_UPGRADE          0x40000000U
#define FLAG_NO_HEADER_FREE   0x80000000U

#define FLAG_ID_MAX           0x001ffffe
#define FLAG_ID_INVALID       0x001fffff

#define FLAG_RATE_POS         21
#define FLAG_RATE_MAX         5
#define FLAG_RATE_INVALID     0


#define FILTER_MODE_ALL_FILES     0
#define FILTER_MODE_DOC_FILES     1
#define FILTER_MODE_CONF_FILES    2

#ifndef RPM4_11_0
#ifdef PATCHED_MGA
#define RPMTAG_RECOMMENDNAME RPMTAG_SUGGESTSNAME
#define RPMTAG_RECOMMENDFLAGS RPMTAG_SUGGESTSFLAGS
#define RPMTAG_RECOMMENDVERSION RPMTAG_SUGGESTSVERSION
#endif
#endif

#ifdef RPM4_11_0
#ifndef RPM4_12_0
#ifndef PATCHED_RH
#define RPMTAG_RECOMMENDNAME RPMTAG_SUGGESTSNAME
#define RPMTAG_RECOMMENDFLAGS RPMTAG_SUGGESTSFLAGS
#define RPMTAG_RECOMMENDVERSION RPMTAG_SUGGESTSVERSION
#endif
#endif
#endif

#if defined(RPM4_12_0) || defined(PATCHED_MGA) || defined(PATCHED_RH)
#define WEAK_DEPS_ARE_SUPPORTED
#endif

#define  BUF_SIZE 65536*3

static ssize_t write_nocheck(int fd, const void *buf, size_t count) {
  return write(fd, buf, count);
}
static int rpmError_callback_data;

static int rpmError_callback(rpmlogRec rec, __attribute__((unused)) rpmlogCallbackData data) {
  write_nocheck(rpmError_callback_data, rpmlogRecMessage(rec), strlen(rpmlogRecMessage(rec)));
  return RPMLOG_DEFAULT;
}

static inline int _run_cb_while_traversing(SV *callback, Header header, VOL I32 flags) {
     dSP;
     URPM__Package pkg = calloc(1, sizeof(struct s_Package));

     pkg->flag = FLAG_ID_INVALID | FLAG_NO_HEADER_FREE;
     pkg->h = header;

     PUSHMARK(SP);
     mXPUSHs(sv_setref_pv(newSVpvs(""), "URPM::Package", pkg));
     PUTBACK;

     int count = call_sv(callback, G_SCALAR | flags);

     SPAGAIN;
     pkg->h = NULL; /* avoid using it anymore, in case it has been copied inside callback */
     return count;
}

static inline  void _header_free(URPM__Package pkg) {
     if (pkg->h && !(pkg->flag & FLAG_NO_HEADER_FREE))
          pkg->h = headerFree(pkg->h);
}

static int rpm_codeset_is_utf8 = 0;

static SV*
newSVpv_utf8(const char *s, STRLEN len)
{
  SV *sv = newSVpv(s, len);
  SvUTF8_on(sv);
  return sv;
}

static void
get_fullname_parts(URPM__Package pkg, char **name, char **version, char **release, char **arch, char **eos) {
  char *_version = NULL, *_release = NULL, *_arch = NULL, *_eos = NULL;

  if (!pkg->info)
    return;
  if ((_eos = strchr(pkg->info, '@')) != NULL) {
    *_eos = 0; /* mark end of string to enable searching backwards */
    if ((_arch = strrchr(pkg->info, '.')) != NULL) {
      *_arch = 0;
      if ((release != NULL || version != NULL || name != NULL) && (_release = strrchr(pkg->info, '-')) != NULL) {
	*_release = 0;
	if ((version != NULL || name != NULL) && (_version = strrchr(pkg->info, '-')) != NULL) {
	  if (name != NULL) *name = pkg->info;
	  if (version != NULL) *version = _version + 1;
	}
	if (release != NULL) *release = _release + 1;
	*_release = '-';
      }
      if (arch != NULL) *arch = _arch + 1;
      *_arch = '.';
    }
    if (eos != NULL) *eos = _eos;
    *_eos = '@';
  }
}

static char *
get_name(const Header header, rpmTag tag) {
  struct rpmtd_s val;

  headerGet(header, tag, &val, HEADERGET_MINMEM);
  char *name = (char *) rpmtdGetString(&val);
  return name ? name : "";
}

static char*
get_arch(const Header header) {
     return headerIsEntry(header, RPMTAG_SOURCERPM) ? get_name(header, RPMTAG_ARCH) : "src";
}

static UV
get_int(const Header header, rpmTag tag) {
  struct rpmtd_s val;

  headerGet(header, tag, &val, HEADERGET_ALLOC);
  return rpmtdGetNumber(&val);
}

static UV
get_int2(const Header header, rpmTag newtag, rpmTag oldtag) {
  struct rpmtd_s val;

  if (!headerGet(header, newtag, &val, HEADERGET_DEFAULT))
      headerGet(header, oldtag, &val, HEADERGET_DEFAULT);
  return rpmtdGetNumber(&val);
}

static UV
get_filesize(const Header h) {
  return get_int2(h, RPMTAG_LONGSIGSIZE, RPMTAG_SIGSIZE) + 440; /* 440 is the rpm header size (?) empirical, but works */
}

static int
print_list_entry(char *buff, int sz, const char *name, rpmsenseFlags flags, const char *evr) {
  int len = strlen(name);
  char *p = buff;

  if (len >= sz || !strncmp(name, "rpmlib(", 7))
    return -1;
  memcpy(p, name, len); p += len;

  if (flags & (RPMSENSE_PREREQ|RPMSENSE_SCRIPT_PREUN|RPMSENSE_SCRIPT_PRE|RPMSENSE_SCRIPT_POSTUN|RPMSENSE_SCRIPT_POST)) {
    if (p - buff + 3 >= sz)
      return -1;
    memcpy(p, "[*]", 4); p += 3;
  }
  if (evr != NULL) {
    len = strlen(evr);
    if (len > 0) {
      if (p - buff + 6 + len >= sz)
        return -1;
      *p++ = '[';
      if (flags & RPMSENSE_LESS) *p++ = '<';
      if (flags & RPMSENSE_GREATER) *p++ = '>';
      if (flags & RPMSENSE_EQUAL) *p++ = '=';
      if ((flags & (RPMSENSE_LESS|RPMSENSE_EQUAL|RPMSENSE_GREATER)) == RPMSENSE_EQUAL) *p++ = '=';
      *p++ = ' ';
      memcpy(p, evr, len); p+= len;
      *p++ = ']';
    }
  }
  *p = 0; /* make sure to mark null char, Is it really necessary ? */

  return p - buff;
}

static int
ranges_overlap(rpmsenseFlags aflags, char *sa, rpmsenseFlags bflags, char *sb) {
  if (!aflags || !bflags)
    return 1; /* really faster to test it there instead of later */
  else {
    int res;
    char *eosa = strchr(sa, ']');
    char *eosb = strchr(sb, ']');
    rpmds dsa, dsb;

    if (eosa) *eosa = 0;
    if (eosb) *eosb = 0;

    dsa = rpmdsSingle(RPMTAG_REQUIRENAME, "", sa, aflags);
    dsb = rpmdsSingle(RPMTAG_REQUIRENAME, "", sb, bflags);
    res = rpmdsCompare(dsa, dsb);
    rpmdsFree(dsa);
    rpmdsFree(dsb);

    if (eosb) *eosb = ']';
    if (eosa) *eosa = ']';

    return res;
  }
}

typedef int (*callback_list_str)(char *s, int slen, const char *name, const rpmsenseFlags flags, const char *evr, void *param);

static int
callback_list_str_xpush(char *s, int slen, const char *name, rpmsenseFlags flags, const char *evr, __attribute__((unused)) void *param) {
  dSP;
  if (s)
    mXPUSHs(newSVpv(s, slen));
  else {
    char buff[4096];
    int len = print_list_entry(buff, sizeof(buff)-1, name, flags, evr);
    if (len >= 0)
      mXPUSHs(newSVpv(buff, len));
  }
  PUTBACK;
  /* returning zero indicates to continue processing */
  return 0;
}

struct cb_overlap_s {
  rpmsenseFlags flags;
  int direction; /* indicate to compare the above at left or right to the iteration element */
  char *name;
  char *evr;
};

static int
callback_list_str_overlap(char *s, int slen, const char *name, rpmsenseFlags flags, const char *evr, void *param) {
  struct cb_overlap_s *os = (struct cb_overlap_s *)param;
  int result = 0;
  char *eos = NULL;
  char *eon = NULL;
  char eosc = '\0';
  char eonc = '\0';

  /* we need to extract name, flags and evr from a full sense information, store result in local copy */
  if (s) {
    if (slen) {
      eos = s + slen;
      eosc = *eos;
      *eos = 0;
    }
    name = s;
    while (*s && *s != ' ' && *s != '[' && *s != '<' && *s != '>' && *s != '=') ++s;
    if (*s) {
      eon = s;
      while (*s) {
	if (*s == ' ' || *s == '[' || *s == '*' || *s == ']');
	else if (*s == '<') flags |= RPMSENSE_LESS;
	else if (*s == '>') flags |= RPMSENSE_GREATER;
	else if (*s == '=') flags |= RPMSENSE_EQUAL;
	else break;
	++s;
      }
      evr = s;
    } else
      evr = "";
  }

  /* mark end of name */
  if (eon) {
       eonc = *eon;
       *eon = 0;
  }
  /* names should be equal, else it will not overlap */
  if (!strcmp(name, os->name)) {
    /* perform overlap according to direction needed, negative for left */
    if (os->direction < 0)
      result = ranges_overlap(os->flags, os->evr, flags, (char *) evr);
    else
      result = ranges_overlap(flags, (char *) evr, os->flags, os->evr);
  }

  /* fprintf(stderr, "cb_list_str_overlap result=%d, os->direction=%d, os->name=%s, os->evr=%s, name=%s, evr=%s\n",
     result, os->direction, os->name, os->evr, name, evr); */

  /* restore s if needed */
  if (eon) *eon = eonc;
  if (eos) *eos = eosc;

  return result;
}

static int
return_list_str(char *s, const Header header, rpmTag tag_name, rpmTag tag_flags, rpmTag tag_version, callback_list_str f, void *param) {
  int count = 0;

  if (s != NULL) {
    char *ps = strchr(s, '@');
    if (tag_flags && tag_version) {
      while(ps != NULL) {
	++count;
	if (f(s, ps-s, NULL, 0, NULL, param))
          return -count;
	s = ps + 1; ps = strchr(s, '@');
      }
      ++count;
      if (f(s, 0, NULL, 0, NULL, param))
        return -count;
    } else {
      char *eos;
      while(ps != NULL) {
	*ps = 0; eos = strchr(s, '['); if (!eos) eos = strchr(s, ' ');
	++count;
	if (f(s, eos ? eos-s : ps-s, NULL, 0, NULL, param)) {
          *ps = '@';
          return -count;
        }
	*ps = '@'; /* restore in memory modified char */
	s = ps + 1; ps = strchr(s, '@');
      }
      eos = strchr(s, '['); if (!eos) eos = strchr(s, ' ');
      ++count;
      if (f(s, eos ? eos-s : 0, NULL, 0, NULL, param))
         return -count;
    }
  } else if (header) {
    struct rpmtd_s list, flags, list_evr;

    if (headerGet(header, tag_name, &list, HEADERGET_EXT)) {
      memset((void*)&flags, 0, sizeof(flags));
      memset((void*)&list_evr, 0, sizeof(list_evr));
      if (tag_flags) headerGet(header, tag_flags, &flags, HEADERGET_DEFAULT);
      if (tag_version) headerGet(header, tag_version, &list_evr, HEADERGET_DEFAULT);
      while (rpmtdNext(&list) >= 0) {
	++count;
	uint32_t *flag = rpmtdNextUint32(&flags);
	if (f(NULL, 0, rpmtdGetString(&list), flag ? *flag : 0, 
	      rpmtdNextString(&list_evr), param)) {
	  rpmtdFreeData(&list);
	  if (tag_flags) rpmtdFreeData(&flags);
	  if (tag_version) rpmtdFreeData(&list_evr);
	  return -count;
	}
      }
      rpmtdFreeData(&list);
      if (tag_flags) rpmtdFreeData(&flags);
      if (tag_version) rpmtdFreeData(&list_evr);
    }
  }
  return count;
}

static int
xpush_simple_list_str(const Header header, rpmTag tag_name) {
  dSP;
  if (header) {
    struct rpmtd_s list;
    const char *val;
    int size;

    if (!headerGet(header, tag_name, &list, HEADERGET_DEFAULT))
        return 0;
    size = rpmtdCount(&list);

    EXTEND(SP, size);
    while ((val = rpmtdNextString(&list)))
        mPUSHs(newSVpv(val, 0));
    rpmtdFreeData(&list);
    PUTBACK;
    return size;
  } else return 0;
}

static void
return_list_number(const Header header, rpmTag tag_name) {
  dSP;
  if (header) {
    struct rpmtd_s list;
    if (headerGet(header, tag_name, &list, HEADERGET_DEFAULT)) {
      int count = rpmtdCount(&list);
      int i;
      EXTEND(SP, count);
      for(i = 0; i < count; i++) {
	rpmtdNext(&list);
	mPUSHs(newSViv(rpmtdGetNumber(&list)));
      }
      rpmtdFreeData(&list);
    }
  }
  PUTBACK;
}

static void
return_list_tag_modifier(const Header header, rpmTag tag_name) {
  dSP;
  int i;
  struct rpmtd_s td;
  if (!headerGet(header, tag_name, &td, HEADERGET_DEFAULT))
    return;
  int count = rpmtdCount(&td);
  rpmtdInit(&td);

  for (i = 0; i < count; i++) {
    char buff[15];
    char *s = buff;
    int32_t tag;
    rpmtdNext(&td);
    tag = rpmtdGetNumber(&td);

    if (tag_name == RPMTAG_FILEFLAGS) {
      if (tag & RPMFILE_CONFIG)    *s++ = 'c';
      if (tag & RPMFILE_DOC)       *s++ = 'd';
      if (tag & RPMFILE_GHOST)     *s++ = 'g';
      if (tag & RPMFILE_LICENSE)   *s++ = 'l';
      if (tag & RPMFILE_MISSINGOK) *s++ = 'm';
      if (tag & RPMFILE_NOREPLACE) *s++ = 'n';
      if (tag & RPMFILE_SPECFILE)  *s++ = 'S';
      if (tag & RPMFILE_README)    *s++ = 'R';
      if (tag & RPMFILE_ICON)      *s++ = 'i';
      if (tag & RPMFILE_PUBKEY)    *s++ = 'p';
    } else {
      rpmtdFreeData(&td);
      return;  
    }
    *s = '\0';
    mXPUSHs(newSVpv(buff, strlen(buff)));
  }
  rpmtdFreeData(&td);
  PUTBACK;
}

static void
return_list_tag(const URPM__Package pkg, rpmTag tag_name) {
  dSP;
  if (pkg->h != NULL) {
    struct rpmtd_s td;
    if (headerGet(pkg->h, tag_name, &td, HEADERGET_DEFAULT)) {
      int32_t count = rpmtdCount(&td);
      if (tag_name == RPMTAG_ARCH)
	mXPUSHs(newSVpv(get_arch(pkg->h), 0));
      else
	switch (rpmtdType(&td)) {
	  case RPM_NULL_TYPE:
	    break;
	  case RPM_CHAR_TYPE:
	  case RPM_INT8_TYPE:
	  case RPM_INT16_TYPE:
	  case RPM_INT32_TYPE:
	    {
	      int i;
              EXTEND(SP, count);
	      for (i=0; i < count; i++) {
		rpmtdNext(&td);
		mPUSHs(newSViv(rpmtdGetNumber(&td)));
	      }
	    }
	    break;
	  case RPM_STRING_TYPE:
	    mPUSHs(newSVpv(rpmtdGetString(&td), 0));
	    break;
	  case RPM_BIN_TYPE:
	    break;
	  case RPM_STRING_ARRAY_TYPE:
	    {
	      int i;
              EXTEND(SP, count);
              rpmtdInit(&td);
	      for (i = 0; i < count; i++)
		mPUSHs(newSVpv(rpmtdNextString(&td), 0));
	    }
	    break;
	  case RPM_I18NSTRING_TYPE:
	    break;
	  case RPM_INT64_TYPE:
	    break;
	}
    }
  } else {
    char *name, *version, *release, *arch, *eos, *data = NULL;
    int len;
    switch (tag_name) {
      case RPMTAG_NAME:
	{
	  get_fullname_parts(pkg, &name, &version, &release, &arch, &eos);
	  data = name;
	  len = version-name;
	}
	break;
      case RPMTAG_VERSION:
	{
	  get_fullname_parts(pkg, &name, &version, &release, &arch, &eos);
	  data = version;
	  len = release-version;
	}
	break;
      case RPMTAG_RELEASE:
	{
	  get_fullname_parts(pkg, &name, &version, &release, &arch, &eos);
	  data = release;
	  len = arch-release;
	}
	break;
      case RPMTAG_ARCH:
	{
	  get_fullname_parts(pkg, &name, &version, &release, &arch, &eos);
	  mXPUSHs(newSVpv(arch, eos-arch));
	}
	break;
      case RPMTAG_SUMMARY:
	mXPUSHs(newSVpv(pkg->summary, 0));
	break;
      default:
	croak("unexpected tag %s", rpmTagGetName(tag_name));
	break;
    }
    if (data) {
      if (len < 1) croak("invalid fullname");
      mXPUSHs(newSVpv(data, len - 1));
    }
  }
  PUTBACK;
}


static void
return_files(const Header header, int filter_mode) {
  dSP;
  if (header) {
    char buff[4096];
    char *p; const char *s;
    STRLEN len;
    unsigned int i;

    struct rpmtd_s td_flags, td_fmodes;
    int32_t *flags = NULL;
    if (filter_mode) {
      headerGet(header, RPMTAG_FILEFLAGS, &td_flags, HEADERGET_DEFAULT);
      headerGet(header, RPMTAG_FILEMODES, &td_fmodes, HEADERGET_DEFAULT);
      flags = td_flags.data;
    }

    struct rpmtd_s td_baseNames, td_dirIndexes, td_dirNames, td_list;
    headerGet(header, RPMTAG_BASENAMES, &td_baseNames, HEADERGET_DEFAULT);
    headerGet(header, RPMTAG_DIRINDEXES, &td_dirIndexes, HEADERGET_DEFAULT);
    headerGet(header, RPMTAG_DIRNAMES, &td_dirNames, HEADERGET_DEFAULT);

    char **baseNames = td_baseNames.data;
    char **dirNames = td_dirNames.data;
    int32_t *dirIndexes = td_dirIndexes.data;
    int is_oldfilenames = !baseNames || !dirNames || !dirIndexes;

    if (is_oldfilenames) {
      if (!headerGet(header, RPMTAG_OLDFILENAMES, &td_list, HEADERGET_DEFAULT))
        return;
      rpmtdInit(&td_list);
    }

    rpm_count_t count = is_oldfilenames ? rpmtdCount(&td_list) : rpmtdCount(&td_baseNames);
    for(i = 0; i < count; i++) {
      if (is_oldfilenames) {
	s = rpmtdNextString(&td_list);
	len = strlen(s);
      } else {
	len = strlen(dirNames[dirIndexes[i]]);
	if (len >= sizeof(buff)) continue;
	memcpy(p = buff, dirNames[dirIndexes[i]], len + 1); p += len;
	len = strlen(baseNames[i]);
	if (p - buff + len >= sizeof(buff)) continue;
	memcpy(p, baseNames[i], len + 1); p += len;
	s = buff;
	len = p-buff;
      }

      if (filter_mode) {
	if ((filter_mode & FILTER_MODE_CONF_FILES) && flags && (flags[i] & RPMFILE_CONFIG) == 0) continue;
	if ((filter_mode & FILTER_MODE_DOC_FILES) && flags && (flags[i] & RPMFILE_DOC) == 0) continue;
      }

      mXPUSHs(newSVpv(s, len));
    }

    rpmtdFreeData(&td_baseNames);
    rpmtdFreeData(&td_dirNames);
    if (is_oldfilenames)
      rpmtdFreeData(&td_list);
  }
  PUTBACK;
}

static void
return_problems(rpmps ps, int translate_message, int raw_message) {
  dSP;
  if (ps && rpmpsNumProblems(ps) > 0) {
    rpmpsi iterator = rpmpsInitIterator(ps);
    while (rpmpsNextIterator(iterator) >= 0) {
      rpmProblem p = rpmpsGetProblem(iterator);

      if (translate_message) {
	/* translate error using rpm localization */
	const char *buf = rpmProblemString(p);
	SV *sv = newSVpv(buf, 0);
	if (rpm_codeset_is_utf8) SvUTF8_on(sv);
	mXPUSHs(sv);
	_free(buf);
      }
      if (raw_message) {
	const char *pkgNEVR = rpmProblemGetPkgNEVR(p) ? rpmProblemGetPkgNEVR(p) : "";
	const char *altNEVR = rpmProblemGetAltNEVR(p) ? rpmProblemGetAltNEVR(p) : "";
	const char *s = rpmProblemGetStr(p) ? rpmProblemGetStr(p) : "";
	SV *sv;

	switch (rpmProblemGetType(p)) {
	case RPMPROB_BADARCH:
	  sv = newSVpvf("badarch@%s", pkgNEVR); break;

	case RPMPROB_BADOS:
	  sv = newSVpvf("bados@%s", pkgNEVR); break;

	case RPMPROB_PKG_INSTALLED:
	  sv = newSVpvf("installed@%s", pkgNEVR); break;

	case RPMPROB_BADRELOCATE:
	  sv = newSVpvf("badrelocate@%s@%s", pkgNEVR, s); break;

	case RPMPROB_NEW_FILE_CONFLICT:
	case RPMPROB_FILE_CONFLICT:
	  sv = newSVpvf("conflicts@%s@%s@%s", pkgNEVR, altNEVR, s); break;

	case RPMPROB_OLDPACKAGE:
	  sv = newSVpvf("installed@%s@%s", pkgNEVR, altNEVR); break;

	case RPMPROB_DISKSPACE:
	  sv = newSVpvf("diskspace@%s@%s@%lld", pkgNEVR, s, (long long)rpmProblemGetDiskNeed(p)); break;
	case RPMPROB_DISKNODES:
	  sv = newSVpvf("disknodes@%s@%s@%lld", pkgNEVR, s, (long long)rpmProblemGetDiskNeed(p)); break;
	case RPMPROB_REQUIRES:
	  sv = newSVpvf("requires@%s@%s", pkgNEVR, altNEVR+2); break;

	case RPMPROB_CONFLICT:
	  sv = newSVpvf("conflicts@%s@%s", pkgNEVR, altNEVR+2); break;

	case RPMPROB_OBSOLETES:
	  sv = newSVpvf("obsoletes@%s@%s", pkgNEVR, altNEVR+2); break;

	default:
	  sv = newSVpvf("unknown@%s", pkgNEVR); break;
	}
	mXPUSHs(sv);
      }
    }
    rpmpsFreeIterator(iterator);
  }
  PUTBACK;
}

static char *
pack_list(const Header header, rpmTag tag_name, rpmTag tag_flags, rpmTag tag_version) {
  char buff[BUF_SIZE];
  char *p = buff;

  struct rpmtd_s td;
  if (headerGet(header, tag_name, &td, HEADERGET_EXT)) {
    char **list = td.data;
    char **list_evr = NULL;
    rpmTag *flags = NULL;
    unsigned int i;
    
    struct rpmtd_s td_flags, td_list_evr;
    if (tag_flags   && headerGet(header, tag_flags,   &td_flags, HEADERGET_DEFAULT))    flags    = td_flags.data;
    if (tag_version && headerGet(header, tag_version, &td_list_evr, HEADERGET_DEFAULT)) list_evr = td_list_evr.data;
    for(i = 0; i < rpmtdCount(&td); i++) {
      int len = print_list_entry(p, sizeof(buff)-(p-buff)-1, list[i], flags ? flags[i] : 0, list_evr ? list_evr[i] : NULL);
      if (len < 0) continue;
      p += len;
      *p++ = '@';
    }
    if (p > buff) p[-1] = 0;

    free(list);
    free(list_evr);
  }

  return p > buff ? memcpy(malloc(p-buff), buff, p-buff) : NULL;
}

static void
pack_header(const URPM__Package pkg) {
  if (pkg->h) {
    if (pkg->info == NULL) {
      char buff[1024];
      const char *p = buff;
      const char *nvr = headerGetAsString(pkg->h, RPMTAG_NVR);
      const char *arch = get_arch(pkg->h);
      p += 1 + snprintf(buff, sizeof(buff), "%s.%s@%" PRIu64 "@%" PRIu64 "@%s", nvr, arch,
		    get_int(pkg->h, RPMTAG_EPOCH), get_int2(pkg->h, RPMTAG_LONGSIZE, RPMTAG_SIZE),
		    get_name(pkg->h, RPMTAG_GROUP));
      pkg->info = memcpy(malloc(p-buff), buff, p-buff);
    }
    if (pkg->filesize == 0) pkg->filesize = get_filesize(pkg->h);
    if (pkg->requires == NULL)
      pkg->requires = pack_list(pkg->h, RPMTAG_REQUIRENAME, RPMTAG_REQUIREFLAGS, RPMTAG_REQUIREVERSION);
#ifdef WEAK_DEPS_ARE_SUPPORTED
    if (pkg->recommends == NULL)
      pkg->recommends = pack_list(pkg->h, RPMTAG_RECOMMENDNAME, 0, 0);
#endif
    if (pkg->obsoletes == NULL)
      pkg->obsoletes = pack_list(pkg->h, RPMTAG_OBSOLETENAME, RPMTAG_OBSOLETEFLAGS, RPMTAG_OBSOLETEVERSION);
    if (pkg->conflicts == NULL)
      pkg->conflicts = pack_list(pkg->h, RPMTAG_CONFLICTNAME, RPMTAG_CONFLICTFLAGS, RPMTAG_CONFLICTVERSION);
    if (pkg->provides == NULL)
      pkg->provides = pack_list(pkg->h, RPMTAG_PROVIDENAME, RPMTAG_PROVIDEFLAGS, RPMTAG_PROVIDEVERSION);
    if (pkg->summary == NULL) {
      char *summary = get_name(pkg->h, RPMTAG_SUMMARY);
      int len = 1 + strlen(summary);

      pkg->summary = memcpy(malloc(len), summary, len);
    }

    _header_free(pkg);
    pkg->h = NULL;
  }
}

static void
update_hash_entry(HV *hash, const char *name, STRLEN len, int force, IV use_sense, const URPM__Package pkg) {
  SV** isv;

  if (!len) len = strlen(name);
  if ((isv = hv_fetch(hash, name, len, force))) {
    /* check if an entry has been found or created, it should so be updated */
    if (!SvROK(*isv) || SvTYPE(SvRV(*isv)) != SVt_PVHV) {
      SV* choice_set = (SV*)newHV();
      if (choice_set) {
	SvREFCNT_dec(*isv); /* drop the old as we are changing it */
	if (!(*isv = newRV_noinc(choice_set))) {
	  SvREFCNT_dec(choice_set);
	  *isv = &PL_sv_undef;
	}
      }
    }
    if (isv && *isv != &PL_sv_undef) {
      char id[8];
      STRLEN id_len = snprintf(id, sizeof(id), "%d", pkg->flag & FLAG_ID_MASK);
      SV **sense = hv_fetch((HV*)SvRV(*isv), id, id_len, 1);
      if (sense && use_sense) sv_setiv(*sense, use_sense);
    }
  }
}

static void
update_provides(const URPM__Package pkg, HV *provides) {
  if (pkg->h) {
    int len;
    struct rpmtd_s td, td_flags;
    unsigned int i;

    /* examine requires for files which need to be marked in provides */
    if (headerGet(pkg->h, RPMTAG_REQUIRENAME, &td, HEADERGET_DEFAULT)) {
      for (i = 0; i < rpmtdCount(&td); ++i) {
	const char *s = rpmtdNextString(&td);
	len = strlen(s);
	if (s[0] == '/') (void)hv_fetch(provides, s, len, 1);
      }
    }

    /* update all provides */
    if (headerGet(pkg->h, RPMTAG_PROVIDENAME, &td, HEADERGET_DEFAULT)) {
      char **list = td.data;
      rpmsenseFlags *flags = NULL;
      if (headerGet(pkg->h, RPMTAG_PROVIDEFLAGS, &td_flags, HEADERGET_DEFAULT))
	flags = td_flags.data;
      for (i = 0; i < rpmtdCount(&td); ++i) {
	len = strlen(list[i]);
	if (!strncmp(list[i], "rpmlib(", 7)) continue;
	update_hash_entry(provides, list[i], len, 1, flags && flags[i] & (RPMSENSE_PREREQ|RPMSENSE_SCRIPT_PREUN|RPMSENSE_SCRIPT_PRE|RPMSENSE_SCRIPT_POSTUN|RPMSENSE_SCRIPT_POST|RPMSENSE_LESS|RPMSENSE_EQUAL|RPMSENSE_GREATER),
			     pkg);
      }
    }
  } else {
    char *ps, *s, *es;

    if ((s = pkg->requires) != NULL && *s != 0) {
      ps = strchr(s, '@');
      /* examine requires for files which need to be marked in provides */
      while(ps != NULL) {
	if (s[0] == '/') {
	  *ps = 0; es = strchr(s, '['); if (!es) es = strchr(s, ' '); *ps = '@';
	  (void)hv_fetch(provides, s, es != NULL ? es-s : ps-s, 1);
	}
	s = ps + 1; ps = strchr(s, '@');
      }
      if (s[0] == '/') {
      es = strchr(s, '['); if (!es) es = strchr(s, ' ');
	(void)hv_fetch(provides, s, es != NULL ? (U32)(es-s) : strlen(s), 1);
      }
    }

    /* update all provides */
    if ((s = pkg->provides) != NULL && *s != 0) {
      ps = strchr(s, '@');
      while(ps != NULL) {
	*ps = 0; es = strchr(s, '['); if (!es) es = strchr(s, ' '); *ps = '@';
	update_hash_entry(provides, s, es != NULL ? es-s : ps-s, 1, es != NULL, pkg);
	s = ps + 1; ps = strchr(s, '@');
      }
      es = strchr(s, '['); if (!es) es = strchr(s, ' ');
      update_hash_entry(provides, s, es != NULL ? es-s : 0, 1, es != NULL, pkg);
    }
  }
}

static void
update_obsoletes(const URPM__Package pkg, HV *obsoletes) {
  if (pkg->h) {
    struct rpmtd_s td;

    /* update all provides */
    if (headerGet(pkg->h, RPMTAG_OBSOLETENAME, &td, HEADERGET_DEFAULT)) {
      unsigned int i;
      for (i = 0; i < rpmtdCount(&td); ++i)
	update_hash_entry(obsoletes, rpmtdNextString(&td), 0, 1, 0, pkg);
    }
  } else {
    char *ps, *s;

    if ((s = pkg->obsoletes) != NULL && *s != 0) {
      char *es;

      ps = strchr(s, '@');
      while(ps != NULL) {
	*ps = 0; es = strchr(s, '['); if (!es) es = strchr(s, ' '); *ps = '@';
	update_hash_entry(obsoletes, s, es != NULL ? es-s : ps-s, 1, 0, pkg);
	s = ps + 1; ps = strchr(s, '@');
      }
      es = strchr(s, '['); if (!es) es = strchr(s, ' ');
      update_hash_entry(obsoletes, s, es != NULL ? es-s : 0, 1, 0, pkg);
    }
  }
}

static void
update_provides_files(const URPM__Package pkg, HV *provides) {
  if (pkg->h) {
    STRLEN len;
    unsigned int i;

    struct rpmtd_s td_baseNames, td_dirIndexes, td_dirNames;
    if (headerGet(pkg->h, RPMTAG_BASENAMES, &td_baseNames, HEADERGET_DEFAULT) &&
	headerGet(pkg->h, RPMTAG_DIRINDEXES, &td_dirIndexes, HEADERGET_DEFAULT) &&
	headerGet(pkg->h, RPMTAG_DIRNAMES, &td_dirNames, HEADERGET_DEFAULT)) {

      char **baseNames = td_baseNames.data;
      char **dirNames = td_dirNames.data;
      int32_t *dirIndexes = td_dirIndexes.data;

      char buff[4096];
      char *p;

      for(i = 0; i < rpmtdCount(&td_baseNames); i++) {
	len = strlen(dirNames[dirIndexes[i]]);
	if (len >= sizeof(buff)) continue;
	memcpy(p = buff, dirNames[dirIndexes[i]], len + 1); p += len;
	len = strlen(baseNames[i]);
	if (p - buff + len >= sizeof(buff)) continue;
	memcpy(p, baseNames[i], len + 1); p += len;

	update_hash_entry(provides, buff, p-buff, 0, 0, pkg);
      }

      rpmtdFreeData(&td_baseNames);
      rpmtdFreeData(&td_dirNames);
    } else {
      struct rpmtd_s td;
      
      if (headerGet(pkg->h, RPMTAG_OLDFILENAMES, &td, HEADERGET_DEFAULT)) {
	for (i = 0; i < rpmtdCount(&td); i++)
	  update_hash_entry(provides, rpmtdNextString(&td), 0, 0, 0, pkg);

	rpmtdFreeData(&td);
      }
    }
  }
}

static FD_t open_compressed_file(char *filename) {
  char *t;
  rpmCompressedMagic compressed = COMPRESSED_OTHER;
  int rc = rpmFileIsCompressed(filename, &compressed);
  switch (compressed) {
  case COMPRESSED_BZIP2: t = "r.bzip2"; break;
  case COMPRESSED_LZMA:
  case COMPRESSED_XZ:
    t = "r.xz"; break;
#ifdef RPM4_14_0
  case COMPRESSED_ZSTD:
    t = "r.zstd"; break;
#endif
  case COMPRESSED_OTHER:
  default:
    t = "r.gzip"; break;
  }
  if (rc)
    return NULL;
  FD_t f = Fopen(filename, "r.fdio");
  return Fdopen(f, t);
}

static FD_t
open_archive(char *filename, int *empty_archive) {
  int fd;
  FD_t rfd = NULL;
  struct {
    char header[4];
    char toc_d_count[4];
    char toc_l_count[4];
    char toc_f_count[4];
    char toc_str_size[4];
    char uncompress[40];
    char trailer[4];
  } buf;

  fd = open(filename, O_RDONLY);
  if (fd >= 0) {
    int pos = lseek(fd, -(int)sizeof(buf), SEEK_END);
    if (read(fd, &buf, sizeof(buf)) != sizeof(buf) || strncmp(buf.header, "cz[0", 4) || strncmp(buf.trailer, "0]cz", 4)) {
      /* this is not an archive, open it without magic, but first rewind at begin of file */
      lseek(fd, 0, SEEK_SET);
      rfd = fdDup(fd);
      close(fd);
      return rfd;
    } else if (pos == 0) {
      *empty_archive = 1;
    } else {
      /* this is an archive, prepare for reading with uncompress defined inside */
      rfd = Fopen(filename, "r.fdio");
      if (!strncmp(buf.uncompress, "gzip", 4))
           rfd = Fdopen(rfd, "r.gzip");
      else if (!strncmp(buf.uncompress, "bzip2", 4))
           rfd = Fdopen(rfd, "r.bzip2");
      else if (!strncmp(buf.uncompress, "xz", 2) || !strncmp(buf.uncompress, "lzma", 4))
           rfd = Fdopen(rfd, "r.xz");
      else if (!strncmp(buf.uncompress, "zstd", 4))
           rfd = Fdopen(rfd, "r.zstd");
      else {
           free(rfd);
           rfd = NULL;
      }
    }
  }
  close(fd); // we rely on EBADF in testsuite
  return rfd;
}

static int
call_package_callback(SV *urpm, SV *sv_pkg, SV *callback) {
  if (sv_pkg != NULL && callback != NULL) {
    int count;

    /* now, a callback will be called for sure */
    dSP;
    PUSHMARK(SP);
    EXTEND(SP, 2);
    PUSHs(urpm);
    PUSHs(sv_pkg);
    PUTBACK;
    count = call_sv(callback, G_SCALAR);
    SPAGAIN;
    if (count == 1 && !POPi) {
      /* package should not be added in depslist, so we free it */
      SvREFCNT_dec(sv_pkg);
      sv_pkg = NULL;
    }
    PUTBACK;
  }

  return sv_pkg != NULL;
}

static void
push_in_depslist(struct s_Package *_pkg, SV *urpm, AV *depslist, SV *callback, HV *provides, HV *obsoletes, int packing) {
    SV *sv_pkg = sv_setref_pv(newSVpvs(""), "URPM::Package", _pkg);
    if (call_package_callback(urpm, sv_pkg, callback)) {
      if (provides) {
	update_provides(_pkg, provides);
	update_provides_files(_pkg, provides);
      }
      if (obsoletes) update_obsoletes(_pkg, obsoletes);
      if (packing) pack_header(_pkg);
      av_push(depslist, sv_pkg);
    }
}

static int
parse_line(AV *depslist, HV *provides, HV *obsoletes, URPM__Package pkg, char *buff, SV *urpm, SV *callback) {
  char *tag, *data;

  if (buff[0] == 0)
    return 1;
  else if ((tag = buff)[0] == '@' && (data = strchr(tag+1, '@')) != NULL) {
    *tag++ = *data++ = 0;
    int data_len = 1+strlen(data);
    if (!strcmp(tag, "info")) {
      pkg->info = memcpy(malloc(data_len), data, data_len);
      pkg->flag &= ~FLAG_ID_MASK;
      pkg->flag |= 1 + av_len(depslist);
      URPM__Package _pkg = memcpy(malloc(sizeof(struct s_Package)), pkg, sizeof(struct s_Package));
      push_in_depslist(_pkg, urpm, depslist, callback, provides, obsoletes, 0);
      // reset package, next line will be for another one
      memset(pkg, 0, sizeof(struct s_Package));
    } else if (!strcmp(tag, "filesize"))
      pkg->filesize = atoll(data);
    else {
      char **ptr = NULL;
      if (!strcmp(tag, "requires"))
        ptr = &pkg->requires;
      else if (!strcmp(tag, "suggests") || !strcmp(tag, "recommends"))
        ptr = &pkg->recommends;
      else if (!strcmp(tag, "obsoletes"))
        ptr = &pkg->obsoletes;
      else if (!strcmp(tag, "conflicts"))
        ptr = &pkg->conflicts;
      else if (!strcmp(tag, "provides"))
        ptr = &pkg->provides;
      else if (!strcmp(tag, "summary"))
        ptr = &pkg->summary;

      if (ptr)
        free(*ptr), *ptr = memcpy(malloc(data_len), data, data_len);
    }
    return 1;
  } else {
    fprintf(stderr, "bad line <%s>\n", buff);
    return 0;
  }
}

#if 0
/*
 * this code is unused since August 2007 and hasn't work since MDK8.1 and rpm 4 (2001!!!).
 */
static void pack_rpm_header(Header *h) {
  Header packed = headerNew();

  HeaderIterator hi = headerInitIterator(*h);
  struct rpmtd_s td;
  while (headerNext(hi, &td)) {
      // fprintf(stderr, "adding %s %d\n", tagname(tag), c);
      headerPut(packed, &td, HEADERPUT_DEFAULT);
      rpmtdFreeData(&td);
  }

  headerFreeIterator(hi);
  *h = headerFree(*h);

  *h = packed;
}

static void drop_tags(Header *h) {
  headerDel(*h, RPMTAG_FILEUSERNAME); /* user ownership is correct */
  headerDel(*h, RPMTAG_FILEGROUPNAME); /* group ownership is correct */
  headerDel(*h, RPMTAG_FILEMTIMES); /* correct time without it */
  headerDel(*h, RPMTAG_FILEINODES); /* hardlinks work without it */
  headerDel(*h, RPMTAG_FILEDEVICES); /* it is the same number for every file */
  headerDel(*h, RPMTAG_FILESIZES); /* ? */
  headerDel(*h, RPMTAG_FILERDEVS); /* it seems unused. always empty */
  headerDel(*h, RPMTAG_FILEVERIFYFLAGS); /* only used for -V */
  headerDel(*h, RPMTAG_FILEDIGESTALGOS); /* only used for -V */
  headerDel(*h, RPMTAG_FILEDIGESTS); /* only used for -V */ /* alias: RPMTAG_FILEMD5S */ 
  /* keep RPMTAG_FILEFLAGS for %config (rpmnew) to work */
  /* keep RPMTAG_FILELANGS for %lang (_install_langs) to work */
  /* keep RPMTAG_FILELINKTOS for checking conflicts between symlinks */
  /* keep RPMTAG_FILEMODES otherwise it segfaults with excludepath */

  /* keep RPMTAG_POSTIN RPMTAG_POSTUN RPMTAG_PREIN RPMTAG_PREUN */
  /* keep RPMTAG_TRIGGERSCRIPTS RPMTAG_TRIGGERVERSION RPMTAG_TRIGGERFLAGS RPMTAG_TRIGGERNAME */
  /* small enough, and only in some packages. not needed per se */

  headerDel(*h, RPMTAG_ICON);
  headerDel(*h, RPMTAG_GIF);
  headerDel(*h, RPMTAG_EXCLUSIVE);
  headerDel(*h, RPMTAG_COOKIE);
  headerDel(*h, RPMTAG_VERIFYSCRIPT);

  /* always the same for our packages */
  headerDel(*h, RPMTAG_VENDOR);
  headerDel(*h, RPMTAG_DISTRIBUTION);

  /* keep RPMTAG_SIGSIZE, useful to tell the size of the rpm file (+440) */

  headerDel(*h, RPMTAG_DSAHEADER);
  headerDel(*h, RPMTAG_SHA1HEADER);
  headerDel(*h, RPMTAG_SIGMD5);
  headerDel(*h, RPMTAG_SIGGPG);

  pack_rpm_header(h);
}
#endif

static int
update_header(char *filename, URPM__Package pkg, __attribute__((unused)) int keep_all_tags, int vsflags) {
  int d = open(filename, O_RDONLY);

  if (d >= 0) {
    unsigned char sig[4];

    if (read(d, &sig, sizeof(sig)) == sizeof(sig)) {
      lseek(d, 0, SEEK_SET);
      // Is it RPM lead?
      if (sig[0] == 0xed && sig[1] == 0xab && sig[2] == 0xee && sig[3] == 0xdb) {
	FD_t fd = fdDup(d);
	Header header;
	rpmts ts;
	pkg->filesize = fdSize(fd);

	close(d);
	ts = rpmtsCreate();
	rpmtsSetVSFlags(ts, _RPMVSF_NOSIGNATURES | vsflags);
	if (fd != NULL && rpmReadPackageFile(ts, fd, filename, &header) == 0 && header) {
	  Fclose(fd);

	  _header_free(pkg);
	  pkg->h = header;
	  pkg->flag &= ~FLAG_NO_HEADER_FREE;

	  /*if (!keep_all_tags) drop_tags(&pkg->h);*/
	  (void)rpmtsFree(ts);
	  return 1;
	}
	(void)rpmtsFree(ts);
      } else if (sig[0] == 0x8e && sig[1] == 0xad && sig[2] == 0xe8 && sig[3] == 0x01) {
	// or is it RPM header magic?
	FD_t fd = fdDup(d);

	close(d);
	if (fd != NULL) {
	  _header_free(pkg);
	  pkg->h = headerRead(fd, HEADER_MAGIC_YES);
	  pkg->flag &= ~FLAG_NO_HEADER_FREE;
	  Fclose(fd);
	  return 1;
	}
      } else close(d);
    } else close(d);
  }
  return 0;
}

static int
read_config_files(int force) {
  static int already = 0;
  int rc = 0;

  if (!already || force) {
    rc = rpmReadConfigFiles(NULL, NULL);
    already = (rc == 0); /* set config as load only if it succeed */
  }
  return rc;
}

static rpmVSFlags
ts_nosignature(rpmts ts) {
  return rpmtsSetVSFlags(ts, _RPMVSF_NODIGESTS | _RPMVSF_NOSIGNATURES);
}

/* we don't use the header arg, but we do use $urpm passed in data by Trans_run() -> rpmtsSetNotifyCallback() */
static void *rpmRunTransactions_callback(__attribute__((unused)) const void *h,
					 const rpmCallbackType what, 
					 const rpm_loff_t amount, 
					 const rpm_loff_t total,
					 fnpyKey pkgKey,
					 rpmCallbackData data) {
  static struct timeval tprev;
  static struct timeval tcurr;
  static FD_t fd = NULL;
  long delta;
  int i;
  struct s_TransactionData *td = data;
  SV *callback = NULL;
  char *callback_type = NULL;
  char *callback_subtype = NULL;

  if (!td)
    return NULL;

  switch (what) {
    case RPMCALLBACK_INST_OPEN_FILE:
      callback = td->callback_open;
      callback_type = "open";
      break;
    case RPMCALLBACK_INST_CLOSE_FILE:
      callback = td->callback_close;
      callback_type = "close";
      break;
    case RPMCALLBACK_TRANS_START:
    case RPMCALLBACK_TRANS_PROGRESS:
    case RPMCALLBACK_TRANS_STOP:
      callback = td->callback_trans;
      callback_type = "trans";
      break;
    case RPMCALLBACK_UNINST_START:
    case RPMCALLBACK_UNINST_PROGRESS:
    case RPMCALLBACK_UNINST_STOP:
      callback = td->callback_uninst;
      callback_type = "uninst";
      break;
#ifdef RPM4_14_2
    case RPMCALLBACK_VERIFY_START:
    case RPMCALLBACK_VERIFY_PROGRESS:
    case RPMCALLBACK_VERIFY_STOP:
      callback = td->callback_verify;
      callback_type = "verify";
      break;
#endif
    case RPMCALLBACK_INST_START:
    case RPMCALLBACK_INST_PROGRESS:
#ifdef RPM4_10_0
    case RPMCALLBACK_INST_STOP:
#endif
      callback = td->callback_inst;
      callback_type = "inst";
      break;
#ifdef RPM4_10_0
    case RPMCALLBACK_SCRIPT_START:
    case RPMCALLBACK_SCRIPT_STOP:
      callback = td->callback_inst;
      callback_type = "script";
      break;
#endif
    case RPMCALLBACK_CPIO_ERROR:
    case RPMCALLBACK_SCRIPT_ERROR:
    case RPMCALLBACK_UNPACK_ERROR:
      callback = td->callback_error;
      callback_type = "error";
      break;
#ifdef RPM4_13_0
    case RPMCALLBACK_ELEM_PROGRESS:
      callback = td->callback_elem;
      callback_type = "elem";
      break;
#endif
    default:
      break;
  }

  if (callback != NULL) {
    switch (what) {
      case RPMCALLBACK_INST_START:
      case RPMCALLBACK_TRANS_START:
      case RPMCALLBACK_UNINST_START:
#ifdef RPM4_14_2
      case RPMCALLBACK_VERIFY_START:
#endif
	callback_subtype = "start";
	gettimeofday(&tprev, NULL);
	break;
      case RPMCALLBACK_INST_PROGRESS:
      case RPMCALLBACK_TRANS_PROGRESS:
      case RPMCALLBACK_UNINST_PROGRESS:
#ifdef RPM4_14_2
      case RPMCALLBACK_VERIFY_PROGRESS:
#endif
	callback_subtype = "progress";
	gettimeofday(&tcurr, NULL);
	delta = 1000000 * (tcurr.tv_sec - tprev.tv_sec) + (tcurr.tv_usec - tprev.tv_usec);
	if (delta < td->min_delta && amount < total - 1)
	  callback = NULL; /* avoid calling too often a given callback */
	else
	  tprev = tcurr;
	break;
#ifdef RPM4_10_0
      case RPMCALLBACK_INST_STOP:
#endif
      case RPMCALLBACK_TRANS_STOP:
      case RPMCALLBACK_UNINST_STOP:
#ifdef RPM4_14_2
      case RPMCALLBACK_VERIFY_STOP:
#endif
	callback_subtype = "stop";
	break;
      case RPMCALLBACK_CPIO_ERROR:
	callback_subtype = "cpio";
	break;
#ifdef RPM4_13_0
      case RPMCALLBACK_ELEM_PROGRESS:
	callback_subtype = "progress";
	break;
#endif
      case RPMCALLBACK_SCRIPT_ERROR:
	callback_subtype = "script";
	break;
      case RPMCALLBACK_UNPACK_ERROR:
	callback_subtype = "unpack";
	break;
      default:
	break;
    }

    if (callback != NULL) {
      /* now, a callback will be called for sure */
      dSP;
      ENTER;
      SAVETMPS;
      PUSHMARK(SP);
      EXTEND(SP, callback_subtype == NULL ? 3 : 6);
      PUSHs(td->data);
      mPUSHs(newSVpv(callback_type, 0));
      PUSHs(pkgKey != NULL ? sv_2mortal(newSViv((long)pkgKey - 1)) : &PL_sv_undef);
      if (callback_subtype != NULL) {
	mPUSHs(newSVpv(callback_subtype, 0));
	mPUSHs(newSViv(amount));
	mPUSHs(newSViv(total));
      }
      PUTBACK;
      i = call_sv(callback, callback == td->callback_open ? G_SCALAR : G_DISCARD);
      SPAGAIN;
      if (callback == td->callback_open) {
	if (i != 1) croak("callback_open should return a file handle");
	i = POPi;
	fd = fdDup(i);
	if (fd) {
	  fd = fdLink(fd);
	  Fcntl(fd, F_SETFD, (void *)1); /* necessary to avoid forked/execed process to lock removable media */
	}
	PUTBACK;
      } else if (callback == td->callback_close) {
	if (fd) {
	  Fclose(fd);
	  fd = NULL;
	}
      }
      FREETMPS;
      LEAVE;
    }
  }
  return callback == td->callback_open ? fd : NULL;
}

static rpmDbiTag
rpmtag_from_string(char *tag)
{
    if (!strcmp(tag, "name"))
      return RPMDBI_NAME;
    else if (!strcmp(tag, "whatprovides"))
      return RPMDBI_PROVIDENAME;
    else if (!strcmp(tag, "whatrequires"))
      return RPMDBI_REQUIRENAME;
    else if (!strcmp(tag, "whatconflicts"))
      return RPMDBI_CONFLICTNAME;
    else if (!strcmp(tag, "group"))
      return RPMDBI_GROUP;
    else if (!strcmp(tag, "triggeredby"))
      return RPMDBI_TRIGGERNAME;
    else if (!strcmp(tag, "path"))
      return RPMDBI_BASENAMES;
    else if (!strcmp(tag, "nvra"))
      return RPMDBI_LABEL;
    else croak("unknown tag [%s]", tag);
}

static unsigned mask_from_string(char *name) {
  unsigned mask;
  if (!strcmp(name, "skip")) mask = FLAG_SKIP;
  else if (!strcmp(name, "disable_obsolete")) mask = FLAG_DISABLE_OBSOLETE;
  else if (!strcmp(name, "installed")) mask = FLAG_INSTALLED;
  else if (!strcmp(name, "requested")) mask = FLAG_REQUESTED;
  else if (!strcmp(name, "required")) mask = FLAG_REQUIRED;
  else if (!strcmp(name, "upgrade")) mask = FLAG_UPGRADE;
  else croak("unknown flag: %s", name);
  return mask;
}

static int compare_evrs(int lepoch, char*lversion, char*lrelease, int repoch, char*rversion, char*rrelease) {
    int compare;
    compare = lepoch - repoch;
    if (!compare) {
      compare = rpmvercmp(lversion, rversion);
      if (!compare && rrelease)
	compare = rpmvercmp(lrelease, rrelease);
    }
    return compare;
}

static int get_e_v_r(URPM__Package pkg, int *epoch, char **version, char **release, char **arch) {
    if (pkg->info) {
      char *s, *eos;

      if ((s = strchr(pkg->info, '@')) != NULL) {
	if ((eos = strchr(s+1, '@')) != NULL)
          *eos = 0; /* mark end of string to enable searching backwards */
	*epoch = atoi(s+1);
	if (eos != NULL) *eos = '@';
      } else
	*epoch = 0;
      get_fullname_parts(pkg, NULL, version, release, arch, &eos);
      /* temporarily mark end of each substring */
      (*release)[-1] = 0;
      (*arch)[-1] = 0;
      return 1;
    } else if (pkg->h) {
      *epoch = get_int(pkg->h, RPMTAG_EPOCH);
      *version = get_name(pkg->h, RPMTAG_VERSION);
      *release = get_name(pkg->h, RPMTAG_RELEASE);
      *arch = get_arch(pkg->h);
      return 1;
    }
    return 0;
}


#line 1521 "URPM.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 1665 "URPM.c"

XS_EUPXS(XS_URPM__Package_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"URPM::Package::DESTROY",
			"pkg")
;
#line 1517 "URPM.xs"
  free(pkg->info);
  free(pkg->requires);
  free(pkg->recommends);
  free(pkg->obsoletes);
  free(pkg->conflicts);
  free(pkg->provides);
  free(pkg->rflags);
  free(pkg->summary);
  _header_free(pkg);
  free(pkg);
#line 1696 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_URPM__Package_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_name)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"pkg", "URPM::Package")
;
#line 1536 "URPM.xs"
  if (pkg->info) {
    char *name, *version, *release, *arch, *eos;
    char *res;
    STRLEN end;

    get_fullname_parts(pkg, &name, &version, &release, &arch, &eos);
    switch (ix) {
    case 1:  res = version; end = release - version; break;
    case 2:  res = release; end = arch-release;      break;
    case 3:  res = arch;    end = eos-arch+1;        break;
    default: res = name;    end = version - name;
    }
    if (end < 1) croak("invalid fullname");
    mXPUSHs(newSVpv(res, end-1));
  } else if (pkg->h) {
    char *str;
    switch (ix) {
    case 1:  str = get_name(pkg->h, RPMTAG_VERSION); break;
    case 2:  str = get_name(pkg->h, RPMTAG_RELEASE); break;
    case 3:  str = get_arch(pkg->h); break;
    default: str = get_name(pkg->h, RPMTAG_NAME);
    }
    mXPUSHs(newSVpv(str, 0));
  }
#line 1748 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Package_EVR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_EVR)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::EVR",
			"pkg", "URPM::Package")
;
#line 1565 "URPM.xs"
    if (pkg->info) {
      char *s, *eos;
      char *version, *arch;
      int epoch;

      if ((s = strchr(pkg->info, '@')) != NULL) {
	if ((eos = strchr(s+1, '@')) != NULL)
          *eos = 0; /* mark end of string to enable searching backwards */
	epoch = atoi(s+1);
	if (eos != NULL) *eos = '@';
      } else
	epoch = 0;
      get_fullname_parts(pkg, NULL, &version, NULL, &arch, &eos);
      if (epoch == 0)
         mXPUSHs(newSVpv(version, arch-version-1));
      else {
         char *res;
         arch--;
         *arch = '\0';
         asprintf(&res, "%d:%s", epoch, version);
         mXPUSHs(newSVpv(res, 0));
         *arch = '.'; /* restore info string modified */
      }
    } else if (pkg->h) {
         char *s = headerGetAsString(pkg->h, RPMTAG_EVR);
         mXPUSHs(newSVpv(s, 0));
         free(s);
    }
#line 1804 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Package_is_arch_compat__XS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_is_arch_compat__XS)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::is_arch_compat__XS",
			"pkg", "URPM::Package")
;
#line 1598 "URPM.xs"
#line 1832 "URPM.c"
#line 1599 "URPM.xs"
  read_config_files(0);
  if (pkg->info) {
    char *arch;
    char *eos;

    get_fullname_parts(pkg, NULL, NULL, NULL, &arch, &eos);
    *eos = 0;
    RETVAL = rpmMachineScore(RPM_MACHTABLE_INSTARCH, arch);
    *eos = '@';
  } else if (pkg->h && headerIsEntry(pkg->h, RPMTAG_SOURCERPM)) {
    char *arch = get_name(pkg->h, RPMTAG_ARCH);
    RETVAL = rpmMachineScore(RPM_MACHTABLE_INSTARCH, arch);
  } else {
    RETVAL = 0;
  }
#line 1849 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Package_summary); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_summary)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::summary",
			"pkg", "URPM::Package")
;
#line 1621 "URPM.xs"
  if (pkg->summary) {
    mXPUSHs(newSVpv_utf8(pkg->summary, 0));
  } else if (pkg->h) {
    mXPUSHs(newSVpv_utf8(get_name(pkg->h, RPMTAG_SUMMARY), 0));
  }
#line 1882 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Package_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_description)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"pkg", "URPM::Package")
;
#line 1633 "URPM.xs"
  if (pkg->h) {
       rpmTag tag = ix == 0 ? RPMTAG_DESCRIPTION : RPMTAG_PACKAGER;
       mXPUSHs(newSVpv_utf8(get_name(pkg->h, tag), 0));
  }
#line 1915 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Package_sourcerpm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_sourcerpm)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"pkg", "URPM::Package")
;
#line 1650 "URPM.xs"
  if (pkg->h) {
       rpmTag tag;
       switch (ix) {
       case 1:  tag = RPMTAG_BUILDHOST;     break;
       case 2:  tag = RPMTAG_URL;           break;
       case 3:  tag = RPMTAG_LICENSE;       break;
       case 4:  tag = RPMTAG_DISTRIBUTION;  break;
       case 5:  tag = RPMTAG_VENDOR;        break;
       case 6:  tag = RPMTAG_OS;            break;
       case 7:  tag = RPMTAG_PAYLOADFORMAT; break;
       default: tag = RPMTAG_SOURCERPM;     break;
       }
       mXPUSHs(newSVpv(get_name(pkg->h, tag), 0));
  }
#line 1958 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Package_buildtime); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_buildtime)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"pkg", "URPM::Package")
;
#line 1671 "URPM.xs"
  if (pkg->h)
    RETVAL = get_int(pkg->h, ix == 1 ? RPMTAG_INSTALLTID : RPMTAG_BUILDTIME);
  else
    RETVAL = 0;
#line 1991 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Package_fullname); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_fullname)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
#line 1683 "URPM.xs"
  I32 gimme = GIMME_V;
#line 2010 "URPM.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::fullname",
			"pkg", "URPM::Package")
;
#line 1685 "URPM.xs"
  if (pkg->info) {
    if (gimme == G_SCALAR) {
      char *eos;
      if ((eos = strchr(pkg->info, '@')) != NULL) {
	mXPUSHs(newSVpv(pkg->info, eos-pkg->info));
      }
    } else if (gimme == G_ARRAY) {
      char *name, *version, *release, *arch, *eos;
      get_fullname_parts(pkg, &name, &version, &release, &arch, &eos);
      if (version - name < 1 || release - version < 1 || arch - release < 1)
	  croak("invalid fullname");
      EXTEND(SP, 4);
      mPUSHs(newSVpv(name, version-name-1));
      mPUSHs(newSVpv(version, release-version-1));
      mPUSHs(newSVpv(release, arch-release-1));
      mPUSHs(newSVpv(arch, eos-arch));
    }
  } else if (pkg->h) {
    char *arch = get_arch(pkg->h);

    if (gimme == G_SCALAR) {
      char *s = headerGetAsString(pkg->h, RPMTAG_NVR);
      mXPUSHs(newSVpvf("%s.%s", s, arch));
      free(s);
    } else if (gimme == G_ARRAY) {
      EXTEND(SP, 4);
      mPUSHs(newSVpv(get_name(pkg->h, RPMTAG_NAME), 0));
      mPUSHs(newSVpv(get_name(pkg->h, RPMTAG_VERSION), 0));
      mPUSHs(newSVpv(get_name(pkg->h, RPMTAG_RELEASE), 0));
      mPUSHs(newSVpv(arch, 0));
    }
  }
#line 2054 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Package_epoch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_epoch)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::epoch",
			"pkg", "URPM::Package")
;
#line 1722 "URPM.xs"
  if (pkg->info) {
    char *s, *eos;

    if ((s = strchr(pkg->info, '@')) != NULL) {
      if ((eos = strchr(s+1, '@')) != NULL)
         *eos = 0; /* mark end of string to enable searching backwards */
      RETVAL = atoi(s+1);
      if (eos != NULL) *eos = '@';
    } else
      RETVAL = 0;
  } else if (pkg->h) {
    RETVAL = get_int(pkg->h, RPMTAG_EPOCH);
  } else RETVAL = 0;
#line 2095 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Package_compare_pkg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_compare_pkg)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "lpkg, rpkg");
    {
	URPM__Package	lpkg;
	URPM__Package	rpkg;
#line 1743 "URPM.xs"
  int compare = 0;
  int lepoch, repoch;
  char *lversion, *lrelease, *larch;
  char *rversion, *rrelease, *rarch;
#line 2116 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    lpkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::compare_pkg",
			"lpkg", "URPM::Package")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    rpkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::compare_pkg",
			"rpkg", "URPM::Package")
;
#line 1748 "URPM.xs"
  if (lpkg == rpkg) RETVAL = 0;
  else {
    if (!get_e_v_r(lpkg, &lepoch, &lversion, &lrelease, &larch))
      croak("undefined package");

    if (!get_e_v_r(rpkg, &repoch, &rversion, &rrelease, &rarch)) {
      /* restore info string modified */
      if (lpkg->info) {
	lrelease[-1] = '-';
	larch[-1] = '.';
      }
      croak("undefined package");
    }
    compare = compare_evrs(lepoch, lversion, lrelease, repoch, rversion, rrelease);
    // equal? compare arches too
    if (!compare) {
	  int lscore, rscore;
	  char *eolarch = strchr(larch, '@');
	  char *eorarch = strchr(rarch, '@');

	  read_config_files(0);
	  if (eolarch) *eolarch = 0; lscore = rpmMachineScore(RPM_MACHTABLE_INSTARCH, larch);
	  if (eorarch) *eorarch = 0; rscore = rpmMachineScore(RPM_MACHTABLE_INSTARCH, rarch);
	  if (lscore == 0) {
	    if (rscore == 0)
              /* Nanar: TODO check this 
               * hu ?? what is the goal of strcmp, some of arch are equivalent */
	      compare = strcmp(larch, rarch);
	    else
	      compare = -1;
	  } else {
	    if (rscore == 0)
	      compare = 1;
	    else
	      compare = rscore - lscore; /* score are lower for better */
	  }
	  if (eolarch) *eolarch = '@';
	  if (eorarch) *eorarch = '@';
    }
    /* restore info string modified */
    if (lpkg->info) {
      lrelease[-1] = '-';
      larch[-1] = '.';
    }
    if (rpkg->info) {
      rrelease[-1] = '-';
      rarch[-1] = '.';
    }
    RETVAL = compare;
  }
#line 2190 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Package_compare); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_compare)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pkg, evr");
    {
	URPM__Package	pkg;
	char *	evr = (char *)SvPV_nolen(ST(1))
;
#line 1806 "URPM.xs"
  int _epoch, repoch = 0;
  char *_version, *_release, *_eos;
#line 2210 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::compare",
			"pkg", "URPM::Package")
;
#line 1809 "URPM.xs"
  if (!get_e_v_r(pkg, &_epoch, &_version, &_release, &_eos))
      croak("undefined package");

  char *epoch = NULL, *version, *release;
  if (!strncmp(evr, "URPM::Package=", 14))
      croak("compare() must not be called with a package reference as argument; use compare_pkg() instead");

  /* extract epoch and version from evr */
  version = evr;
  while (*version && isdigit(*version)) version++;
  if (*version == ':') {
    epoch = evr;
    *version++ = 0;
    if (!*epoch) epoch = "0";
    version[-1] = ':'; /* restore in memory modification */
  } else {
    /* there is no epoch defined, so assume epoch = 0 */
    version = evr;
  }
  if ((release = strrchr(version, '-')) != NULL)
     *release++ = 0;
  repoch = epoch && *epoch ? atoi(epoch) : 0;

  RETVAL = compare_evrs(_epoch, _version, _release, repoch, version, release);
  /* restore info string modified */
  if (pkg->info) {
    _release[-1] = '-';
    _eos[-1] = '.';
  }
  if (release)
    release[-1] = '-'; /* restore in memory modification */
#line 2255 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Package_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	UV	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::size",
			"pkg", "URPM::Package")
;
#line 1847 "URPM.xs"
  if (pkg->info) {
    char *s, *eos;

    if ((s = strchr(pkg->info, '@')) != NULL && (s = strchr(s+1, '@')) != NULL) {
      if ((eos = strchr(s+1, '@')) != NULL)
        *eos = 0; /* mark end of string to enable searching backwards */
      RETVAL = atoll(s+1);
      if (eos != NULL) *eos = '@';
    } else
      RETVAL = 0;
  } else if (pkg->h)
    RETVAL = get_int2(pkg->h, RPMTAG_LONGSIZE, RPMTAG_SIZE);
  else
    RETVAL = 0;
#line 2297 "URPM.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Package_set_filesize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_set_filesize)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pkg, filesize");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
	UV	filesize = (UV)SvUV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::set_filesize",
			"pkg", "URPM::Package")
;
#line 1869 "URPM.xs"
  pkg->filesize = filesize;
#line 2328 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Package_filesize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_filesize)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	UV	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::filesize",
			"pkg", "URPM::Package")
;
#line 1875 "URPM.xs"
  if (pkg->filesize)
    RETVAL = pkg->filesize;
  else if (pkg->h)
    RETVAL = get_filesize(pkg->h);
  else RETVAL = 0;
#line 2361 "URPM.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Package_group); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_group)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::group",
			"pkg", "URPM::Package")
;
#line 1887 "URPM.xs"
  if (pkg->info) {
    char *s;

    if ((s = strchr(pkg->info, '@')) != NULL && (s = strchr(s+1, '@')) != NULL && (s = strchr(s+1, '@')) != NULL) {
      char *eos = strchr(s+1, '@');
      mXPUSHs(newSVpv_utf8(s+1, eos != NULL ? eos-s-1 : 0));
    }
  } else if (pkg->h)
    mXPUSHs(newSVpv_utf8(get_name(pkg->h, RPMTAG_GROUP), 0));
#line 2398 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Package_filename); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_filename)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::filename",
			"pkg", "URPM::Package")
;
#line 1901 "URPM.xs"
  if (pkg->info) {
    char *eon;

    if ((eon = strchr(pkg->info, '@')) != NULL && strlen(eon) >= 3) {
	char savbuf[4];
	memcpy(savbuf, eon, 4); /* there should be at least epoch and size described so (@0@0 minimum) */
	memcpy(eon, ".rpm", 4);
	mXPUSHs(newSVpv(pkg->info, eon-pkg->info+4));
	memcpy(eon, savbuf, 4);
    }
  } else if (pkg->h) {
    char *nvr = headerGetAsString(pkg->h, RPMTAG_NVR);
    char *arch = get_arch(pkg->h);

    mXPUSHs(newSVpvf("%s.%s.rpm", nvr, arch));
  }
#line 2442 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Package_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_id)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::id",
			"pkg", "URPM::Package")
;
#line 1922 "URPM.xs"
  int id = pkg->flag & FLAG_ID_MASK;
  if (id <= FLAG_ID_MAX)
    mXPUSHs(newSViv(id));
#line 2473 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Package_set_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_set_id)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pkg, id=-1");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
	int	id;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::set_id",
			"pkg", "URPM::Package")
;

	if (items < 2)
	    id = -1;
	else {
	    id = (int)SvIV(ST(1))
;
	}
#line 1931 "URPM.xs"
  int old_id = pkg->flag & FLAG_ID_MASK;
  if (old_id <= FLAG_ID_MAX)
    mXPUSHs(newSViv(old_id));
  pkg->flag &= ~FLAG_ID_MASK;
  pkg->flag |= id >= 0 && id <= FLAG_ID_MAX ? id : FLAG_ID_INVALID;
#line 2514 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Package_obsoletes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_obsoletes)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"pkg", "URPM::Package")
;
#line 1946 "URPM.xs"
  PUTBACK;
  rpmTag tag, flags, tag_version;
  char *s;
  switch (ix) {
  case 1:  tag = RPMTAG_CONFLICTNAME; s = pkg->conflicts; flags = RPMTAG_CONFLICTFLAGS; tag_version = RPMTAG_CONFLICTVERSION; break;
  case 2:  tag = RPMTAG_PROVIDENAME;  s = pkg->provides;  flags = RPMTAG_PROVIDEFLAGS;  tag_version = RPMTAG_PROVIDEVERSION;  break;
  case 3:  tag = RPMTAG_REQUIRENAME;  s = pkg->requires;  flags = RPMTAG_REQUIREFLAGS;  tag_version = RPMTAG_REQUIREVERSION;  break;
#ifdef WEAK_DEPS_ARE_SUPPORTED
  case 4:  tag = RPMTAG_RECOMMENDNAME;s = pkg->recommends;flags = RPMTAG_RECOMMENDFLAGS;tag_version = RPMTAG_RECOMMENDVERSION;break;
#endif
  default: tag = RPMTAG_OBSOLETENAME; s = pkg->obsoletes; flags = RPMTAG_OBSOLETEFLAGS; tag_version = RPMTAG_OBSOLETEVERSION; break;
  }
  return_list_str(s, pkg->h, tag, flags, tag_version, callback_list_str_xpush, NULL);
  SPAGAIN;
#line 2557 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Package_obsoletes_nosense); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_obsoletes_nosense)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"pkg", "URPM::Package")
;
#line 1971 "URPM.xs"
  PUTBACK;
  rpmTag tag;
  char *s;
  switch (ix) {
  case 1:  tag = RPMTAG_CONFLICTNAME; s = pkg->conflicts; break;
  case 2:  tag = RPMTAG_PROVIDENAME;  s = pkg->provides;  break;
  case 3:  tag = RPMTAG_REQUIRENAME;  s = pkg->requires;  break;
#ifdef WEAK_DEPS_ARE_SUPPORTED
  case 4:  tag = RPMTAG_RECOMMENDNAME;s = pkg->recommends; break;
#endif
  default: tag = RPMTAG_OBSOLETENAME; s = pkg->obsoletes; break;
  }
  return_list_str(s, pkg->h, tag, 0, 0, callback_list_str_xpush, NULL);
  SPAGAIN;
#line 2600 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Package_obsoletes_overlap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_obsoletes_overlap)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "pkg, s");
    {
	URPM__Package	pkg;
	char *	s = (char *)SvPV_nolen(ST(1))
;
#line 1993 "URPM.xs"
  struct cb_overlap_s os;
  char *eon = NULL;
  char eonc = '\0';
  rpmTag tag_name;
  rpmTag tag_flags, tag_version;
#line 2624 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"pkg", "URPM::Package")
;
#line 1999 "URPM.xs"
  switch (ix) {
  case 1:
       tag_name = RPMTAG_PROVIDENAME;
       tag_flags = RPMTAG_PROVIDEFLAGS;
       tag_version = RPMTAG_PROVIDEVERSION;
       break;
  default:
       tag_name = RPMTAG_OBSOLETENAME;
       tag_flags = RPMTAG_OBSOLETEFLAGS;
       tag_version = RPMTAG_OBSOLETEVERSION;
       break;
  }
  os.name = s;
  os.flags = 0;
  while (*s && *s != ' ' && *s != '[' && *s != '<' && *s != '>' && *s != '=') ++s;
  if (*s) {
    eon = s;
    while (*s) {
      if (*s == ' ' || *s == '[' || *s == '*' || *s == ']');
      else if (*s == '<') os.flags |= RPMSENSE_LESS;
      else if (*s == '>') os.flags |= RPMSENSE_GREATER;
      else if (*s == '=') os.flags |= RPMSENSE_EQUAL;
      else break;
      ++s;
    }
    os.evr = s;
  } else
    os.evr = "";
  os.direction = ix == 0 ? -1 : 1;
  /* mark end of name */
  if (eon) {
    eonc = *eon;
    *eon = 0;
  }
  /* return_list_str returns a negative value is the callback has returned non-zero */
  RETVAL = return_list_str(ix == 0 ? pkg->obsoletes : pkg->provides, pkg->h, tag_name, tag_flags, tag_version,
			   callback_list_str_overlap, &os) < 0;
  /* restore end of name */
  if (eon) *eon = eonc;
#line 2677 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Package_buildarchs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_buildarchs)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"pkg", "URPM::Package")
;
#line 2055 "URPM.xs"
  PUTBACK;
       rpmTag tag;
       switch (ix) {
       case 1: tag = RPMTAG_EXCLUDEARCH; break;
       case 2: tag = RPMTAG_EXCLUSIVEARCH; break;
       case 3: tag = RPMTAG_DIRNAMES; break;
       case 4: tag = RPMTAG_FILELINKTOS; break;
       case 5: tag = RPMTAG_FILEMD5S; break;
       case 6: tag = RPMTAG_FILEUSERNAME; break;
       case 7: tag = RPMTAG_FILEGROUPNAME; break;
       case 8: tag = RPMTAG_CHANGELOGNAME; break;
       case 9: tag = RPMTAG_CHANGELOGTEXT; break;
       default: tag = RPMTAG_BUILDARCHS; break;
       }
       xpush_simple_list_str(pkg->h, tag);
  SPAGAIN;
#line 2722 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Package_files); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_files)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"pkg", "URPM::Package")
;
#line 2079 "URPM.xs"
  PUTBACK;
  return_files(pkg->h, ix);
  SPAGAIN;
#line 2754 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Package_files_mtime); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_files_mtime)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"pkg", "URPM::Package")
;
#line 2094 "URPM.xs"
  PUTBACK;
       rpmTag tag;
       switch (ix) {
       case 1: tag = RPMTAG_FILESIZES; break;
       case 2: tag = RPMTAG_FILEUIDS; break;
       case 3: tag = RPMTAG_FILEGIDS; break;
       case 4: tag = RPMTAG_FILEMODES; break;
       case 5: tag = RPMTAG_FILEFLAGS; break;
       case 6: tag = RPMTAG_CHANGELOGTIME; break;
       default: tag = RPMTAG_FILEMTIMES; break;
       }
       return_list_number(pkg->h, tag);
  SPAGAIN;
#line 2796 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Package_queryformat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_queryformat)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pkg, fmt");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
	char *	fmt = (char *)SvPV_nolen(ST(1))
;
#line 2113 "URPM.xs"
  char *s;
#line 2817 "URPM.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::queryformat",
			"pkg", "URPM::Package")
;
#line 2115 "URPM.xs"
  if (pkg->h) {
    s = headerFormat(pkg->h, fmt, NULL);
      if (s)
        mXPUSHs(newSVpv_utf8(s, 0));
  }
#line 2834 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Package_get_tag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_get_tag)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "pkg, tagname");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
	int	tagname = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"pkg", "URPM::Package")
;
#line 2128 "URPM.xs"
  PUTBACK;
  if (ix == 0)
    return_list_tag(pkg, tagname);
  else
    return_list_tag_modifier(pkg->h, tagname);
  SPAGAIN;
#line 2871 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Package_pack_header); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_pack_header)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::pack_header",
			"pkg", "URPM::Package")
;
#line 2140 "URPM.xs"
  pack_header(pkg);
#line 2898 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_URPM__Package_update_header); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_update_header)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "pkg, filename, ...");
    {
	URPM__Package	pkg;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
#line 2147 "URPM.xs"
  int packing = 0;
  int keep_all_tags = 0;
#line 2917 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::update_header",
			"pkg", "URPM::Package")
;
#line 2150 "URPM.xs"
  if (items > 3) {
    int i;
    for (i = 2; i < items-1; i+=2) {
      STRLEN len;
      char *s = SvPV(ST(i), len);

      if (len == 7 && !memcmp(s, "packing", 7))
	packing = SvTRUE(ST(i + 1));
      else if (len == 13 && !memcmp(s, "keep_all_tags", 13))
	keep_all_tags = SvTRUE(ST(i+1));
    }
  }
  RETVAL = update_header(filename, pkg, !packing && keep_all_tags, RPMVSF_DEFAULT);
  if (RETVAL && packing) pack_header(pkg);
#line 2945 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Package_free_header); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_free_header)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::free_header",
			"pkg", "URPM::Package")
;
#line 2171 "URPM.xs"
  _header_free(pkg);
  pkg->h = NULL;
#line 2973 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_URPM__Package_build_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_build_info)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "pkg, fileno, provides_files=NULL, recommends=0");
    {
	URPM__Package	pkg;
	int	fileno = (int)SvIV(ST(1))
;
	char *	provides_files;
	int	recommends;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::build_info",
			"pkg", "URPM::Package")
;

	if (items < 3)
	    provides_files = NULL;
	else {
	    provides_files = (char *)SvPV_nolen(ST(2))
;
	}

	if (items < 4)
	    recommends = 0;
	else {
	    recommends = (int)SvIV(ST(3))
;
	}
#line 2181 "URPM.xs"
  if (pkg->info) {
    char buff[BUF_SIZE];
    UV size;

    /* info line should be the last to be written */
    if (pkg->provides && *pkg->provides) {
      size = snprintf(buff, sizeof(buff), "@provides@%s\n", pkg->provides);
      if (size < sizeof(buff)) {
	if (provides_files && *provides_files) {
	  --size;
	  size += snprintf(buff+size, sizeof(buff)-size, "@%s\n", provides_files);
	}
	write_nocheck(fileno, buff, size);
      } else {
	fprintf(stderr, "buffer overflow: %d < %d for provides\n", size, sizeof(buff));
      }
    }
    if (pkg->conflicts && *pkg->conflicts) {
      size = snprintf(buff, sizeof(buff), "@conflicts@%s\n", pkg->conflicts);
      if (size < sizeof(buff)) write_nocheck(fileno, buff, size);
    }
    if (pkg->obsoletes && *pkg->obsoletes) {
      size = snprintf(buff, sizeof(buff), "@obsoletes@%s\n", pkg->obsoletes);
      if (size < sizeof(buff)) write_nocheck(fileno, buff, size);
    }
    if (pkg->requires && *pkg->requires) {
      size = snprintf(buff, sizeof(buff), "@requires@%s\n", pkg->requires);
      if (size < sizeof(buff)) write_nocheck(fileno, buff, size);
    }
    if (pkg->recommends && *pkg->recommends) {
      size = snprintf(buff, sizeof(buff), recommends ? "@recommends@%s\n" : "@suggests@%s\n", pkg->recommends);
      if (size < sizeof(buff)) write_nocheck(fileno, buff, size);
    }
    if (pkg->summary && *pkg->summary) {
      size = snprintf(buff, sizeof(buff), "@summary@%s\n", pkg->summary);
      if (size < sizeof(buff)) write_nocheck(fileno, buff, size);
    }
    if (pkg->filesize) {
      size = snprintf(buff, sizeof(buff), "@filesize@%" PRIu64 "\n", pkg->filesize);
      if (size < sizeof(buff)) write_nocheck(fileno, buff, size);
    }
    size = snprintf(buff, sizeof(buff), "@info@%s\n", pkg->info);
    write_nocheck(fileno, buff, size);
  } else croak("no info available for package %s",
	  pkg->h ? get_name(pkg->h, RPMTAG_NAME) : "-");
#line 3061 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_URPM__Package_build_header); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_build_header)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pkg, fileno");
    {
	URPM__Package	pkg;
	int	fileno = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::build_header",
			"pkg", "URPM::Package")
;
#line 2232 "URPM.xs"
  if (pkg->h) {
    FD_t fd;

    if ((fd = fdDup(fileno)) != NULL) {
      headerWrite(fd, pkg->h, HEADER_MAGIC_YES);
      Fclose(fd);
    } else croak("unable to get rpmio handle on fileno %d", fileno);
  } else croak("no header available for package");
#line 3096 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_URPM__Package_flag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_flag)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pkg, name");
    {
	URPM__Package	pkg;
	char *	name = (char *)SvPV_nolen(ST(1))
;
#line 2246 "URPM.xs"
  unsigned mask;
#line 3114 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::flag",
			"pkg", "URPM::Package")
;
#line 2248 "URPM.xs"
  mask = mask_from_string(name);
  RETVAL = pkg->flag & mask;
#line 3130 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Package_set_flag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_set_flag)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "pkg, name, value=1");
    {
	URPM__Package	pkg;
	char *	name = (char *)SvPV_nolen(ST(1))
;
	int	value;
#line 2259 "URPM.xs"
  unsigned mask;
#line 3150 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::set_flag",
			"pkg", "URPM::Package")
;

	if (items < 3)
	    value = 1;
	else {
	    value = (int)SvIV(ST(2))
;
	}
#line 2261 "URPM.xs"
  mask = mask_from_string(name);
  RETVAL = pkg->flag & mask;
  if (value) pkg->flag |= mask;
  else       pkg->flag &= ~mask;
#line 3175 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Package_set_flag_skip); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_set_flag_skip)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pkg, value=1");
    {
	URPM__Package	pkg;
	int	value;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"pkg", "URPM::Package")
;

	if (items < 2)
	    value = 1;
	else {
	    value = (int)SvIV(ST(1))
;
	}
#line 2280 "URPM.xs"
  unsigned flag;
  switch (ix) {
  case 1: flag = FLAG_BASE; break;
  case 2: flag = FLAG_DISABLE_OBSOLETE; break;
  case 3: flag = FLAG_INSTALLED; break;
  case 4: flag = FLAG_REQUESTED; break;
  case 5: flag = FLAG_REQUIRED; break;
  case 6: flag = FLAG_UPGRADE; break;
  default: flag = FLAG_SKIP; break;
  }
  RETVAL = pkg->flag & flag;
  if (value) pkg->flag |= flag;
  else       pkg->flag &= ~flag;
#line 3225 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Package_flag_required); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_flag_required)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"pkg", "URPM::Package")
;
#line 2308 "URPM.xs"
  unsigned flag;
  switch (ix) {
  case 1: flag = FLAG_UPGRADE; break;
  case 2: flag = FLAG_DISABLE_OBSOLETE; break;
  case 3: flag = FLAG_REQUESTED; break;
  case 4: flag = FLAG_INSTALLED; break;
  case 5: flag = FLAG_BASE; break;
  case 6: flag = FLAG_SKIP; break;
  default: flag = FLAG_REQUIRED; break;
  }
  RETVAL = pkg->flag & flag;
#line 3265 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Package_flag_selected); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_flag_selected)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::flag_selected",
			"pkg", "URPM::Package")
;
#line 2326 "URPM.xs"
  RETVAL = pkg->flag & FLAG_UPGRADE ? pkg->flag & (FLAG_BASE | FLAG_REQUIRED) : 0;
#line 3294 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Package_flag_available); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_flag_available)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::flag_available",
			"pkg", "URPM::Package")
;
#line 2334 "URPM.xs"
  RETVAL = (pkg->flag & FLAG_INSTALLED && !(pkg->flag & FLAG_UPGRADE)) ||
           (pkg->flag & FLAG_UPGRADE ? pkg->flag & (FLAG_BASE | FLAG_REQUIRED) : 0);
#line 3324 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Package_rate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_rate)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    {
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::rate",
			"pkg", "URPM::Package")
;
#line 2343 "URPM.xs"
  RETVAL = (pkg->flag & FLAG_RATE_MASK) >> FLAG_RATE_POS;
#line 3353 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Package_set_rate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_set_rate)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pkg, rate");
    {
	URPM__Package	pkg;
	int	rate = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::set_rate",
			"pkg", "URPM::Package")
;
#line 2352 "URPM.xs"
  RETVAL = (pkg->flag & FLAG_RATE_MASK) >> FLAG_RATE_POS;
  pkg->flag &= ~FLAG_RATE_MASK;
  pkg->flag |= (rate >= 0 && rate <= FLAG_RATE_MAX ? rate : FLAG_RATE_INVALID) << FLAG_RATE_POS;
#line 3386 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Package_rflags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_rflags)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pkg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
#line 2362 "URPM.xs"
  I32 gimme = GIMME_V;
#line 3405 "URPM.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::rflags",
			"pkg", "URPM::Package")
;
#line 2364 "URPM.xs"
  if (gimme == G_ARRAY && pkg->rflags != NULL) {
    char *s = pkg->rflags;
    char *eos;
    while ((eos = strchr(s, '\t')) != NULL) {
      mXPUSHs(newSVpv(s, eos-s));
      s = eos + 1;
    }
    mXPUSHs(newSVpv(s, 0));
  }
#line 3426 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Package_set_rflags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Package_set_rflags)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "pkg, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Package	pkg;
#line 2378 "URPM.xs"
  I32 gimme = GIMME_V;
  char *new_rflags;
  STRLEN total_len;
  int i;
#line 3448 "URPM.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Package::set_rflags",
			"pkg", "URPM::Package")
;
#line 2383 "URPM.xs"
  total_len = 0;
  for (i = 1; i < items; ++i)
    total_len += SvCUR(ST(i)) + 1;

  new_rflags = malloc(total_len);
  total_len = 0;
  for (i = 1; i < items; ++i) {
    STRLEN len;
    char *s = SvPV(ST(i), len);
    memcpy(new_rflags + total_len, s, len);
    new_rflags[total_len + len] = '\t';
    total_len += len + 1;
  }
  new_rflags[total_len - 1] = 0; /* but mark end-of-string correctly */

  if (gimme == G_ARRAY && pkg->rflags != NULL) {
    char *s = pkg->rflags;
    char *eos;
    while ((eos = strchr(s, '\t')) != NULL) {
      mXPUSHs(newSVpv(s, eos-s));
      s = eos + 1;
    }
    mXPUSHs(newSVpv(s, 0));
  }

  free(pkg->rflags);
  pkg->rflags = new_rflags;
#line 3487 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__DB_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__DB_open)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 2)
       croak_xs_usage(cv,  "prefix=NULL, write_perm=0");
    {
	char *	prefix;
	int	write_perm;
#line 2419 "URPM.xs"
  URPM__DB db;
#line 3505 "URPM.c"
	URPM__DB	RETVAL;

	if (items < 1)
	    prefix = NULL;
	else {
	    prefix = (char *)SvPV_nolen(ST(0))
;
	}

	if (items < 2)
	    write_perm = 0;
	else {
	    write_perm = (int)SvIV(ST(1))
;
	}
#line 2421 "URPM.xs"
  read_config_files(0);
  db = malloc(sizeof(struct s_Transaction));
  db->count = 1;
  db->ts = rpmtsCreate();
  rpmtsSetRootDir(db->ts, prefix && prefix[0] ? prefix : NULL);
  if (rpmtsOpenDB(db->ts, write_perm ? O_RDWR | O_CREAT : O_RDONLY) == 0) {
    RETVAL = db;
  } else {
    RETVAL = NULL;
    (void)rpmtsFree(db->ts);
    free(db);
  }
#line 3534 "URPM.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "URPM::DB", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__DB_rebuild); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__DB_rebuild)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "prefix=NULL");
    {
	char *	prefix;
#line 2440 "URPM.xs"
  rpmts ts;
#line 3556 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (items < 1)
	    prefix = NULL;
	else {
	    prefix = (char *)SvPV_nolen(ST(0))
;
	}
#line 2442 "URPM.xs"
  read_config_files(0);
  ts = rpmtsCreate();
  rpmtsSetRootDir(ts, prefix);
  RETVAL = rpmtsRebuildDB(ts) == 0;
  (void)rpmtsFree(ts);
#line 3572 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__DB_verify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__DB_verify)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "prefix=NULL");
    {
	char *	prefix;
#line 2454 "URPM.xs"
  rpmts ts;
#line 3589 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (items < 1)
	    prefix = NULL;
	else {
	    prefix = (char *)SvPV_nolen(ST(0))
;
	}
#line 2456 "URPM.xs"
  ts = rpmtsCreate();
  rpmtsSetRootDir(ts, prefix);
  RETVAL = rpmtsVerifyDB(ts) == 0;
  rpmtsFree(ts);
#line 3604 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__DB_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__DB_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "db");
    {
	URPM__DB	db;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"URPM::DB::DESTROY",
			"db")
;
#line 2467 "URPM.xs"
  (void)rpmtsFree(db->ts);
  if (!--db->count) free(db);
#line 3632 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_URPM__DB_traverse); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__DB_traverse)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, callback");
    {
	URPM__DB	db;
	SV *	callback = ST(1)
;
#line 2475 "URPM.xs"
  Header header;
  rpmdbMatchIterator mi;
  rpmVSFlags ovsflags;
  int count = 0;
#line 3653 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::DB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::DB::traverse",
			"db", "URPM::DB")
;
#line 2480 "URPM.xs"
  db->ts = rpmtsLink(db->ts);
  ovsflags = ts_nosignature(db->ts);
  mi = rpmtsInitIterator(db->ts, RPMDBI_PACKAGES, NULL, 0);
  while ((header = rpmdbNextIterator(mi))) {
    if (SvROK(callback))
         _run_cb_while_traversing(callback, header, G_DISCARD);
    ++count;
  }
  rpmdbFreeIterator(mi);
  rpmtsSetVSFlags(db->ts, ovsflags);
  (void)rpmtsFree(db->ts);
  RETVAL = count;
#line 3679 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__DB_traverse_tag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__DB_traverse_tag)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "db, tag, names, callback");
    {
	URPM__DB	db;
	char *	tag = (char *)SvPV_nolen(ST(1))
;
	SV *	names = ST(2)
;
	SV *	callback = ST(3)
;
#line 2502 "URPM.xs"
  Header header;
  rpmdbMatchIterator mi;
  int count = 0;
  rpmVSFlags ovsflags;
#line 3705 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::DB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::DB::traverse_tag",
			"db", "URPM::DB")
;
#line 2507 "URPM.xs"
  if (SvROK(names) && SvTYPE(SvRV(names)) == SVt_PVAV) {
    AV* names_av = (AV*)SvRV(names);
    int len = av_len(names_av);
    int i;
    rpmDbiTag rpmtag = rpmtag_from_string(tag);

    for (i = 0; i <= len; ++i) {
      STRLEN str_len;
      SV **isv = av_fetch(names_av, i, 0);
      char *name = SvPV(*isv, str_len);
      db->ts = rpmtsLink(db->ts);
      ovsflags = ts_nosignature(db->ts);
      mi = rpmtsInitIterator(db->ts, rpmtag, name, str_len);
      while ((header = rpmdbNextIterator(mi))) {
	if (SvROK(callback))
	  _run_cb_while_traversing(callback, header, G_DISCARD);
	++count;
      }
      (void)rpmdbFreeIterator(mi);
      rpmtsSetVSFlags(db->ts, ovsflags);
      (void)rpmtsFree(db->ts);
    } 
  } else croak("bad arguments list");
  RETVAL = count;
#line 3743 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__DB_traverse_tag_find); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__DB_traverse_tag_find)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "db, tag, name, callback");
    {
	URPM__DB	db;
	char *	tag = (char *)SvPV_nolen(ST(1))
;
	char *	name = (char *)SvPV_nolen(ST(2))
;
	SV *	callback = ST(3)
;
#line 2541 "URPM.xs"
  Header header;
  rpmdbMatchIterator mi;
#line 3767 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::DB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::DB::traverse_tag_find",
			"db", "URPM::DB")
;
#line 2544 "URPM.xs"
  rpmDbiTag rpmtag = rpmtag_from_string(tag);
  int found = 0;
  rpmVSFlags ovsflags;
  db->ts = rpmtsLink(db->ts);
  ovsflags = ts_nosignature(db->ts);
  mi = rpmtsInitIterator(db->ts, rpmtag, name, 0);
  while ((header = rpmdbNextIterator(mi))) {
      dSP;
      int count = _run_cb_while_traversing(callback, header, 0);

      SPAGAIN;
      if (count == 1) {
	SV* ret = POPs;
	found = SvTRUE(ret);
	PUTBACK;
      }
      if (found) {
	break;
      }
  }
  rpmtsSetVSFlags(db->ts, ovsflags);
  (void)rpmdbFreeIterator(mi);
  (void)rpmtsFree(db->ts);
  RETVAL = found;
#line 3805 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__DB_create_transaction); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__DB_create_transaction)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "db");
    {
	URPM__DB	db;
	URPM__Transaction	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::DB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::DB::create_transaction",
			"db", "URPM::DB")
;
#line 2575 "URPM.xs"
  /* this is *REALLY* dangerous to create a new transaction while another is open,
     so use the db transaction instead. */
  db->ts = rpmtsLink(db->ts);
  ++db->count;
  RETVAL = db;
#line 3837 "URPM.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "URPM::Transaction", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Transaction_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Transaction_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "trans");
    {
	URPM__Transaction	trans;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"URPM::Transaction::DESTROY",
			"trans")
;
#line 2590 "URPM.xs"
  FD_t fd = rpmtsScriptFd(trans->ts);
  if (fd) Fclose(fd);
  (void)rpmtsFree(trans->ts);
  if (!--trans->count) free(trans);
#line 3872 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_URPM__Transaction_set_script_fd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Transaction_set_script_fd)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "trans, fdno");
    {
	URPM__Transaction	trans;
	int	fdno = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Transaction::set_script_fd",
			"trans", "URPM::Transaction")
;
#line 2600 "URPM.xs"
  rpmtsSetScriptFd(trans->ts, fdDup(fdno));
#line 3900 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_URPM__Transaction_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Transaction_add)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "trans, pkg, ...");
    {
	URPM__Transaction	trans;
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Transaction::add",
			"trans", "URPM::Transaction")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Transaction::add",
			"pkg", "URPM::Package")
;
#line 2607 "URPM.xs"
  if ((pkg->flag & FLAG_ID_MASK) <= FLAG_ID_MAX && pkg->h != NULL) {
    int update = 0;
    rpmRelocation *relocations = NULL;
    if (items > 3) {
      int i;
      for (i = 2; i < items-1; i+=2) {
	STRLEN len;
	char *s = SvPV(ST(i), len);

	if (len == 6 && !memcmp(s, "update", 6))
	  update = SvIV(ST(i+1));
	else if (len == 11 && !memcmp(s, "excludepath", 11)) {
	  if (SvROK(ST(i+1)) && SvTYPE(SvRV(ST(i+1))) == SVt_PVAV) {
	    AV *excludepath = (AV*)SvRV(ST(i+1));
	    I32 j = 1 + av_len(excludepath);
	    if (relocations) free(relocations);
	    relocations = calloc(j + 1, sizeof(rpmRelocation));
	    while (--j >= 0) {
	      SV **e = av_fetch(excludepath, j, 0);
	      if (e != NULL && *e != NULL)
		relocations[j].oldPath = SvPV_nolen(*e);
	    }
	  }
	}
      }
    }
    RETVAL = rpmtsAddInstallElement(trans->ts, pkg->h, (fnpyKey)(1+(long)(pkg->flag & FLAG_ID_MASK)), update, relocations) == 0;
    /* free allocated memory, check rpm is copying it just above, at least in 4.0.4 */
    free(relocations);
  } else RETVAL = 0;
#line 3968 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef RPM4_12_0
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_URPM__Transaction_addReinstall); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Transaction_addReinstall)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "trans, pkg");
    {
	URPM__Transaction	trans;
	URPM__Package	pkg;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Transaction::addReinstall",
			"trans", "URPM::Transaction")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "URPM::Package")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    pkg = INT2PTR(URPM__Package,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Transaction::addReinstall",
			"pkg", "URPM::Package")
;
#line 2646 "URPM.xs"
  if ((pkg->flag & FLAG_ID_MASK) <= FLAG_ID_MAX && pkg->h != NULL)
    RETVAL = rpmtsAddReinstallElement(trans->ts, pkg->h, (fnpyKey)(1+(long)(pkg->flag & FLAG_ID_MASK))) == 0;
  else RETVAL = 0;
#line 4013 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_URPM__Transaction_remove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Transaction_remove)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "trans, name");
    {
	URPM__Transaction	trans;
	char *	name = (char *)SvPV_nolen(ST(1))
;
#line 2659 "URPM.xs"
  Header h;
  rpmdbMatchIterator mi;
  int count = 0;
#line 4035 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Transaction::remove",
			"trans", "URPM::Transaction")
;
#line 2663 "URPM.xs"
  mi = rpmtsInitIterator(trans->ts, RPMDBI_LABEL, name, 0);
  while ((h = rpmdbNextIterator(mi))) {
    unsigned int recOffset = rpmdbGetIteratorOffset(mi);
    if (recOffset != 0) {
      rpmtsAddEraseElement(trans->ts, h, recOffset);
      ++count;
    }
  }
  rpmdbFreeIterator(mi);
  RETVAL=count;
#line 4059 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Transaction_traverse); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Transaction_traverse)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "trans, callback");
    {
	URPM__Transaction	trans;
	SV *	callback = ST(1)
;
#line 2681 "URPM.xs"
  rpmdbMatchIterator mi;
  Header h;
  int c = 0;
#line 4080 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Transaction::traverse",
			"trans", "URPM::Transaction")
;
#line 2685 "URPM.xs"
  mi = rpmtsInitIterator(trans->ts, RPMDBI_PACKAGES, NULL, 0);
  while ((h = rpmdbNextIterator(mi))) {
    if (SvROK(callback))
      _run_cb_while_traversing(callback, h, G_DISCARD);
    ++c;
  }
  rpmdbFreeIterator(mi);
  RETVAL = c;
#line 4102 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Transaction_check); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Transaction_check)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "trans, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Transaction	trans;
#line 2700 "URPM.xs"
  I32 gimme = GIMME_V;
  int translate_message = 0;
  int i;
#line 4123 "URPM.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Transaction::check",
			"trans", "URPM::Transaction")
;
#line 2704 "URPM.xs"
  for (i = 1; i < items-1; i+=2) {
    STRLEN len;
    char *s = SvPV(ST(i), len);

    if (len == 17 && !memcmp(s, "translate_message", 17))
      translate_message = SvIV(ST(i+1));
  }
  rpmtsCheck(trans->ts);
    rpmps ps = rpmtsProblems(trans->ts);
    if (rpmpsNumProblems(ps) > 0) {
      if (gimme == G_SCALAR)
	mXPUSHs(newSViv(0));
      else if (gimme == G_ARRAY) {
	/* now translation is handled by rpmlib, but only for version 4.2 and above */
	PUTBACK;
	return_problems(ps, 1, 0);
	SPAGAIN;
      }
    } else if (gimme == G_SCALAR)
      mXPUSHs(newSViv(1));

    rpmpsFree(ps);
#line 4157 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Transaction_order); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Transaction_order)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "trans, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Transaction	trans;
#line 2731 "URPM.xs"
  rpmtransFlags transFlags = RPMTRANS_FLAG_NONE;
  I32 gimme = GIMME_V;
  int i;
#line 4178 "URPM.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Transaction::order",
			"trans", "URPM::Transaction")
;
#line 2735 "URPM.xs"
  for (i = 1; i < items-1; i+=2) {
    STRLEN len;
    char *s = SvPV(ST(i), len);

    if (len == 8 && !memcmp(s, "deploops", 8)) {
      if (SvIV(ST(i+1))) transFlags |= RPMTRANS_FLAG_DEPLOOPS;
    }
  }
  rpmtsSetFlags(trans->ts, transFlags);
  if (rpmtsOrder(trans->ts) == 0) {
    if (gimme == G_SCALAR)
      mXPUSHs(newSViv(1));
  } else {
    if (gimme == G_SCALAR)
      mXPUSHs(newSViv(0));
    else if (gimme == G_ARRAY)
      mXPUSHs(newSVpvs("error while ordering dependencies"));
  }
#line 4208 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM__Transaction_NElements); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Transaction_NElements)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "trans");
    {
	URPM__Transaction	trans;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Transaction::NElements",
			"trans", "URPM::Transaction")
;
#line 2758 "URPM.xs"
  RETVAL = rpmtsNElements(trans->ts);
#line 4237 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Transaction_Element_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Transaction_Element_name)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "trans, index");
    {
	URPM__Transaction	trans;
	int	index = (int)SvIV(ST(1))
;
	char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"trans", "URPM::Transaction")
;
#line 2771 "URPM.xs"
  rpmte te = rpmtsElement(trans->ts, index);
  if (te) {
       switch (ix) {
       case 1:  RETVAL = (char *) rpmteV(te); break;
       case 2:  RETVAL = (char *) rpmteR(te); break;
       case 3:  RETVAL = (char *) rpmteNEVRA(te); break;
       default: RETVAL = (char *) rpmteN(te); break;
       }
  } else {
       RETVAL = NULL;
  }
#line 4279 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM__Transaction_run); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM__Transaction_run)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "trans, data, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	URPM__Transaction	trans;
	SV *	data = ST(1)
;
#line 2790 "URPM.xs"
  struct s_TransactionData td = { NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 100000, data };
  rpmtransFlags transFlags = RPMTRANS_FLAG_NONE;
  int probFilter = 0;
  int translate_message = 0, raw_message = 0;
  int i;
#line 4304 "URPM.c"

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::Transaction")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trans = INT2PTR(URPM__Transaction,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::Transaction::run",
			"trans", "URPM::Transaction")
;
#line 2796 "URPM.xs"
  for (i = 2 ; i < items - 1 ; i += 2) {
    STRLEN len;
    char *s = SvPV(ST(i), len);

    if (len == 4 && !memcmp(s, "test", 4)) {
      if (SvIV(ST(i+1))) transFlags |= RPMTRANS_FLAG_TEST;
    } else if (len == 11 && !memcmp(s, "excludedocs", 11)) {
      if (SvIV(ST(i+1))) transFlags |= RPMTRANS_FLAG_NODOCS;
    } else if (len == 5) {
      if (!memcmp(s, "force", 5)) {
	if (SvIV(ST(i+1))) probFilter |= (RPMPROB_FILTER_REPLACEPKG |
					  RPMPROB_FILTER_REPLACEOLDFILES |
					  RPMPROB_FILTER_REPLACENEWFILES |
					  RPMPROB_FILTER_OLDPACKAGE);
      } else if (!memcmp(s, "delta", 5))
	td.min_delta = SvIV(ST(i+1));
    } else if (len == 6 && !memcmp(s, "nosize", 6)) {
      if (SvIV(ST(i+1))) probFilter |= (RPMPROB_FILTER_DISKSPACE|RPMPROB_FILTER_DISKNODES);
    } else if (len == 9 && !memcmp(s, "noscripts", 9)) {
      if (SvIV(ST(i+1))) transFlags |= (RPMTRANS_FLAG_NOSCRIPTS |
				        RPMTRANS_FLAG_NOPRE |
				        RPMTRANS_FLAG_NOPREUN |
				        RPMTRANS_FLAG_NOPOST |
				        RPMTRANS_FLAG_NOPOSTUN );
    } else if (len == 10 && !memcmp(s, "oldpackage", 10)) {
      if (SvIV(ST(i+1))) probFilter |= RPMPROB_FILTER_OLDPACKAGE;
    } else if (len == 11 && !memcmp(s, "replacepkgs", 11)) {
      if (SvIV(ST(i+1))) probFilter |= RPMPROB_FILTER_REPLACEPKG;
    } else if (len == 11 && !memcmp(s, "raw_message", 11)) {
      raw_message = 1;
    } else if (len == 12 && !memcmp(s, "replacefiles", 12)) {
      if (SvIV(ST(i+1))) probFilter |= RPMPROB_FILTER_REPLACEOLDFILES | RPMPROB_FILTER_REPLACENEWFILES;
    } else if (len == 6 && !memcmp(s, "justdb", 6)) {
      if (SvIV(ST(i+1))) transFlags |= RPMTRANS_FLAG_JUSTDB;
    } else if (len == 10 && !memcmp(s, "ignorearch", 10)) {
      if (SvIV(ST(i+1))) probFilter |= RPMPROB_FILTER_IGNOREARCH;
    } else if (len == 17 && !memcmp(s, "translate_message", 17))
      translate_message = 1;
    else if (len >= 9 && !memcmp(s, "callback_", 9)) {
      if (len == 9+4 && !memcmp(s+9, "open", 4)) {
	if (SvROK(ST(i+1))) td.callback_open = ST(i+1);
      } else if (len == 9+5 && !memcmp(s+9, "close", 5)) {
	if (SvROK(ST(i+1))) td.callback_close = ST(i+1);
      } else if (len == 9+4 && !memcmp(s+9, "elem", 4)) {
	if (SvROK(ST(i+1))) td.callback_elem = ST(i+1);
      } else if (len == 9+5 && !memcmp(s+9, "trans", 5)) {
	if (SvROK(ST(i+1))) td.callback_trans = ST(i+1);
      } else if (len == 9+6 && !memcmp(s+9, "uninst", 6)) {
	if (SvROK(ST(i+1))) td.callback_uninst = ST(i+1);
      } else if (len == 9+6 && !memcmp(s+9, "verify", 6)) {
	if (SvROK(ST(i+1))) td.callback_verify = ST(i+1);
      } else if (len == 9+4 && !memcmp(s+9, "inst", 4)) {
	if (SvROK(ST(i+1))) td.callback_inst = ST(i+1);
      } else if (len == 9+5 && !memcmp(s+9, "error", 5)) {
	if (SvROK(ST(i+1))) td.callback_error = ST(i+1);
      }
    }
  }
  rpmtsSetFlags(trans->ts, transFlags);
  trans->ts = rpmtsLink(trans->ts);
  rpmtsSetNotifyCallback(trans->ts, rpmRunTransactions_callback, &td);
  if (rpmtsRun(trans->ts, NULL, probFilter) > 0) {
    rpmps ps = rpmtsProblems(trans->ts);
    PUTBACK;
    return_problems(ps, translate_message, raw_message || !translate_message);
    SPAGAIN;
    rpmpsFree(ps);
  }
  rpmtsEmpty(trans->ts);
  (void)rpmtsFree(trans->ts);
#line 4386 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM_bind_rpm_textdomain_codeset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_bind_rpm_textdomain_codeset)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 2875 "URPM.xs"
  rpm_codeset_is_utf8 = 1;
  bind_textdomain_codeset("rpm", "UTF-8");
#line 4403 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_URPM_read_config_files); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_read_config_files)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 2881 "URPM.xs"
  RETVAL = (read_config_files(1) == 0); /* force re-read of configuration files */
#line 4420 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM_rpmvercmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_rpmvercmp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "one, two");
    {
	char *	one = (char *)SvPV_nolen(ST(0))
;
	char *	two = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = rpmvercmp(one, two);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM_ranges_overlap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_ranges_overlap)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	char *	a = (char *)SvPV_nolen(ST(0))
;
	char *	b = (char *)SvPV_nolen(ST(1))
;
#line 2895 "URPM.xs"
  char *sa = a, *sb = b;
  int aflags = 0, bflags = 0;
#line 4462 "URPM.c"
	int	RETVAL;
	dXSTARG;
#line 2898 "URPM.xs"
  while (*sa && *sa != ' ' && *sa != '[' && *sa != '<' && *sa != '>' && *sa != '=' && *sa == *sb) {
    ++sa;
    ++sb;
  }
  if ((*sa && *sa != ' ' && *sa != '[' && *sa != '<' && *sa != '>' && *sa != '=') ||
      (*sb && *sb != ' ' && *sb != '[' && *sb != '<' && *sb != '>' && *sb != '=')) {
    /* the strings are sure to be different */
    RETVAL = 0;
  } else {
    while (*sa) {
      if (*sa == ' ' || *sa == '[' || *sa == '*' || *sa == ']');
      else if (*sa == '<') aflags |= RPMSENSE_LESS;
      else if (*sa == '>') aflags |= RPMSENSE_GREATER;
      else if (*sa == '=') aflags |= RPMSENSE_EQUAL;
      else break;
      ++sa;
    }
    while (*sb) {
      if (*sb == ' ' || *sb == '[' || *sb == '*' || *sb == ']');
      else if (*sb == '<') bflags |= RPMSENSE_LESS;
      else if (*sb == '>') bflags |= RPMSENSE_GREATER;
      else if (*sb == '=') bflags |= RPMSENSE_EQUAL;
      else break;
      ++sb;
    }
    RETVAL = ranges_overlap(aflags, sa, bflags, sb);
  }
#line 4493 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM_parse_synthesis__XS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_parse_synthesis__XS)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "urpm, filename, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	urpm = ST(0)
;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
#line 2933 "URPM.xs"
  if (SvROK(urpm) && SvTYPE(SvRV(urpm)) == SVt_PVHV) {
    SV **fdepslist = hv_fetch((HV*)SvRV(urpm), "depslist", 8, 0);
    AV *depslist = fdepslist && SvROK(*fdepslist) && SvTYPE(SvRV(*fdepslist)) == SVt_PVAV ? (AV*)SvRV(*fdepslist) : NULL;
    SV **fprovides = hv_fetch((HV*)SvRV(urpm), "provides", 8, 0);
    HV *provides = fprovides && SvROK(*fprovides) && SvTYPE(SvRV(*fprovides)) == SVt_PVHV ? (HV*)SvRV(*fprovides) : NULL;
    SV **fobsoletes = hv_fetch((HV*)SvRV(urpm), "obsoletes", 9, 0);
    HV *obsoletes = fobsoletes && SvROK(*fobsoletes) && SvTYPE(SvRV(*fobsoletes)) == SVt_PVHV ? (HV*)SvRV(*fobsoletes) : NULL;

    if (depslist != NULL) {
      char buff[BUF_SIZE];
      char *p, *eol;
      int buff_len;
      struct s_Package pkg;
      FD_t f = NULL;
      int start_id = 1 + av_len(depslist);
      SV *callback = NULL;

      if (items > 2) {
	int i;
	for (i = 2; i < items-1; i+=2) {
	  STRLEN len;
	  char *s = SvPV(ST(i), len);

	  if (len == 8 && !memcmp(s, "callback", 8) && SvROK(ST(i+1)))
	    callback = ST(i+1);
	}
      }

      PUTBACK;
      f = open_compressed_file(filename);

      if (f != NULL && !Ferror(f)) {
	// initialize first package
	memset(&pkg, 0, sizeof(struct s_Package));
	buff[sizeof(buff)-1] = 0;
	p = buff;
	int ok = 1;
	while ((buff_len = Fread(p, sizeof(buff)-1-(p-buff), 1, f)) >= 0 &&
	       (buff_len += p-buff)) {
	  buff[buff_len] = 0;
	  p = buff;
	  if ((eol = strchr(p, '\n')) != NULL) {
	    do {
	      *eol++ = 0;
	      if (!parse_line(depslist, provides, obsoletes, &pkg, p, urpm, callback)) {
                ok = 0;
                break;
              }
	      p = eol;
	    } while ((eol = strchr(p, '\n')) != NULL);
	  } else {
	    /* a line larger than sizeof(buff) has been encountered, bad file problably */
	    fprintf(stderr, "invalid line <%s>\n", p);
	    ok = 0;
	    break;
	  }
	    /* move the remaining non-complete-line at beginning */
	    memmove(buff, p, buff_len-(p-buff));
	    /* point to the end of the non-complete-line */
	    p = &buff[buff_len-(p-buff)];
	}
        // EOF:
        if (ok && buff_len > 0
            && !parse_line(depslist, provides, obsoletes, &pkg, p, urpm, callback))
             ok = 0;
	if (Fclose(f) != 0) ok = 0;
	SPAGAIN;
	if (ok) {
	  mXPUSHs(newSViv(start_id));
	  mXPUSHs(newSViv(av_len(depslist)));
	}
      } else {
	  SV **nofatal = hv_fetch((HV*)SvRV(urpm), "nofatal", 7, 0);
	  if (!errno) errno = EINVAL; /* zlib error */
	  if (!nofatal || !SvIV(*nofatal))
	      croak(errno == ENOENT
		      ? "unable to read synthesis file %s"
		      : "unable to uncompress synthesis file %s", filename);
      }
    } else croak("first argument should contain a depslist ARRAY reference");
  } else croak("first argument should be a reference to a HASH");
#line 4595 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM_parse_hdlist__XS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_parse_hdlist__XS)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "urpm, filename, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	urpm = ST(0)
;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
#line 3020 "URPM.xs"
  if (SvROK(urpm) && SvTYPE(SvRV(urpm)) == SVt_PVHV) {
    SV **fdepslist = hv_fetch((HV*)SvRV(urpm), "depslist", 8, 0);
    AV *depslist = fdepslist && SvROK(*fdepslist) && SvTYPE(SvRV(*fdepslist)) == SVt_PVAV ? (AV*)SvRV(*fdepslist) : NULL;
    SV **fprovides = hv_fetch((HV*)SvRV(urpm), "provides", 8, 0);
    HV *provides = fprovides && SvROK(*fprovides) && SvTYPE(SvRV(*fprovides)) == SVt_PVHV ? (HV*)SvRV(*fprovides) : NULL;
    SV **fobsoletes = hv_fetch((HV*)SvRV(urpm), "obsoletes", 9, 0);
    HV *obsoletes = fobsoletes && SvROK(*fobsoletes) && SvTYPE(SvRV(*fobsoletes)) == SVt_PVHV ? (HV*)SvRV(*fobsoletes) : NULL;

    if (depslist != NULL) {
      int empty_archive = 0;
      FD_t fd;

      fd = open_archive(filename, &empty_archive);

      if (empty_archive) {
	  mXPUSHs(newSViv(1 + av_len(depslist)));
	  mXPUSHs(newSViv(av_len(depslist)));
      } else if (fd != NULL && !Ferror(fd)) {
	Header header;
	int start_id = 1 + av_len(depslist);
	int packing = 0;
	SV *callback = NULL;

	if (items > 3) {
	  int i;
	  for (i = 2; i < items-1; i+=2) {
	    STRLEN len;
	    char *s = SvPV(ST(i), len);

	    if (len == 7 && !memcmp(s, "packing", 7))
	      packing = SvTRUE(ST(i+1));
	    else if (len == 8 && !memcmp(s, "callback", 8) && SvROK(ST(i+1)))
	      callback = ST(i+1);
	  }
	}

	PUTBACK;
	do {
	  header = headerRead(fd, HEADER_MAGIC_YES);
	  if (header != NULL) {
	    struct s_Package *_pkg;
	    _pkg = calloc(1, sizeof(struct s_Package));
	    _pkg->flag = 1 + av_len(depslist);
	    _pkg->h = header;
	    push_in_depslist(_pkg, urpm, depslist, callback, provides, obsoletes, packing);
	  }
	} while (header != NULL);

	int ok = Fclose(fd) == 0;

	if (!empty_archive)
	  ok = av_len(depslist) >= start_id;
	SPAGAIN;
	if (ok) {
	  mXPUSHs(newSViv(start_id));
	  mXPUSHs(newSViv(av_len(depslist)));
	}
      } else {
	  SV **nofatal = hv_fetch((HV*)SvRV(urpm), "nofatal", 7, 0);
	  if (!nofatal || !SvIV(*nofatal))
	      croak("cannot open hdlist file %s", filename);
      }
    } else croak("first argument should contain a depslist ARRAY reference");
  } else croak("first argument should be a reference to a HASH");
#line 4680 "URPM.c"
	PUTBACK;
	return;
    }
}

#ifndef RPM4_14_0
#define RPMVSF_NOPAYLOAD RPMVSF_NOSHA1
#define RPMVSF_NOSHA256HEADER RPMVSF_NOMD5HEADER
#endif

XS_EUPXS(XS_URPM_parse_rpm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_parse_rpm)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "urpm, filename, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	urpm = ST(0)
;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
#line 3095 "URPM.xs"
  if (SvROK(urpm) && SvTYPE(SvRV(urpm)) == SVt_PVHV) {
    SV **fdepslist = hv_fetch((HV*)SvRV(urpm), "depslist", 8, 0);
    AV *depslist = fdepslist && SvROK(*fdepslist) && SvTYPE(SvRV(*fdepslist)) == SVt_PVAV ? (AV*)SvRV(*fdepslist) : NULL;
    SV **fprovides = hv_fetch((HV*)SvRV(urpm), "provides", 8, 0);
    HV *provides = fprovides && SvROK(*fprovides) && SvTYPE(SvRV(*fprovides)) == SVt_PVHV ? (HV*)SvRV(*fprovides) : NULL;
    SV **fobsoletes = hv_fetch((HV*)SvRV(urpm), "obsoletes", 8, 0);
    HV *obsoletes = fobsoletes && SvROK(*fobsoletes) && SvTYPE(SvRV(*fobsoletes)) == SVt_PVHV ? (HV*)SvRV(*fobsoletes) : NULL;

    if (depslist != NULL) {
      struct s_Package *_pkg;
      int packing = 0;
      int keep_all_tags = 0;
      SV *callback = NULL;
      rpmVSFlags vsflags = RPMVSF_DEFAULT;

      if (items > 3) {
	int i;
	for (i = 2; i < items-1; i+=2) {
	  STRLEN len;
	  char *s = SvPV(ST(i), len);

	  if (len == 7 && !memcmp(s, "packing", 7))
	    packing = SvTRUE(ST(i + 1));
	  else if (len == 13 && !memcmp(s, "keep_all_tags", 13))
	    keep_all_tags = SvTRUE(ST(i+1));
	  else if (len == 8 && !memcmp(s, "callback", 8) && SvROK(ST(i+1)))
	    callback = ST(i+1);
	  else if (SvIV(ST(i+1))) {
             if (len == 5) {
                if (!memcmp(s, "nopgp", 5))
                  vsflags |= (RPMVSF_NOPAYLOAD | RPMVSF_NOSHA1HEADER);
                else if (!memcmp(s, "nogpg", 5))
                  vsflags |= (RPMVSF_NOPAYLOAD | RPMVSF_NOSHA1HEADER);
                else if (!memcmp(s, "nomd5", 5))
                  vsflags |= (RPMVSF_NOMD5 | RPMVSF_NOSHA256HEADER);
                else if (!memcmp(s, "norsa", 5))
                  vsflags |= (RPMVSF_NORSA | RPMVSF_NORSAHEADER);
                else if (!memcmp(s, "nodsa", 5))
                  vsflags |= (RPMVSF_NODSA | RPMVSF_NODSAHEADER);
             } else if (len == 9) {
                if (!memcmp(s, "nodigests", 9))
                  vsflags |= _RPMVSF_NODIGESTS;
                else if (!memcmp(s, "nopayload", 9))
                  vsflags |= _RPMVSF_NOPAYLOAD;
             }
          } 
	}
      }
      PUTBACK;
      _pkg = calloc(1, sizeof(struct s_Package));
      _pkg->flag = 1 + av_len(depslist);

      if (update_header(filename, _pkg, keep_all_tags, vsflags)) {
	push_in_depslist(_pkg, urpm, depslist, callback, provides, obsoletes, packing);
	SPAGAIN;
	/* only one element read */
	mXPUSHs(newSViv(av_len(depslist)));
	mXPUSHs(newSViv(av_len(depslist)));
      } else free(_pkg);
    } else croak("first argument should contain a depslist ARRAY reference");
  } else croak("first argument should be a reference to a HASH");
#line 4766 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM_verify_rpm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_verify_rpm)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "filename, ...");
    {
	char *	filename = (char *)SvPV_nolen(ST(0))
;
#line 3161 "URPM.xs"
  FD_t fd;
  int i, oldlogmask;
  rpmVSFlags vsflags;
#line 4786 "URPM.c"
	int	RETVAL;
	dXSTARG;
#line 3165 "URPM.xs"
  /* Don't display error messages */
  oldlogmask = rpmlogSetMask(RPMLOG_UPTO(RPMLOG_PRI(4)));
  vsflags = RPMVSF_DEFAULT;
  for (i = 1 ; i < items - 1 ; i += 2) {
    STRLEN len;
    char *s = SvPV(ST(i), len);
    if (SvIV(ST(i+1))) {
      if (len == 9 && !strncmp(s, "nodigests", 9))
        vsflags |= _RPMVSF_NODIGESTS;
      else if (len == 12 && !strncmp(s, "nosignatures", 12))
        vsflags |= _RPMVSF_NOSIGNATURES;
    }
  }
  fd = Fopen(filename, "r");
  if (fd == NULL)
    RETVAL = 0;
  else {
    Header h;
    read_config_files(0);
    rpmts ts = rpmtsCreate();
    rpmtsSetRootDir(ts, "/");
    rpmtsOpenDB(ts, O_RDONLY);
    rpmtsSetVSFlags(ts, vsflags);
    RETVAL = (rpmReadPackageFile(ts, fd, filename, &h) == RPMRC_OK);
    Fclose(fd);
    if (h)
      h = headerFree(h);
    (void)rpmtsFree(ts);
  }
  rpmlogSetMask(oldlogmask);

#line 4821 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM_get_gpg_fingerprint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_get_gpg_fingerprint)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "filename");
    {
	char *	filename = (char *)SvPV_nolen(ST(0))
;
#line 3204 "URPM.xs"
    uint8_t fingerprint[sizeof(pgpKeyID_t)];
    char fingerprint_str[sizeof(pgpKeyID_t) * 2 + 1];
    const uint8_t *pkt = NULL;
    size_t pktlen = 0;
    int rc;

#line 4844 "URPM.c"
	char *	RETVAL;
	dXSTARG;
#line 3211 "URPM.xs"
    memset (fingerprint, 0, sizeof (fingerprint));
    if ((rc = pgpReadPkts(filename, (uint8_t ** ) &pkt, &pktlen)) <= 0)
	pktlen = 0;
    else if (rc != PGPARMOR_PUBKEY)
	pktlen = 0;
    else {
	unsigned int i;
#ifdef RPM4_14_0
        pgpPubkeyKeyID (pkt, pktlen, fingerprint);
#else
	pgpPubkeyFingerprint (pkt, pktlen, fingerprint);
#endif
   	for (i = 0; i < sizeof (pgpKeyID_t); i++)
	    sprintf(&fingerprint_str[i*2], "%02x", fingerprint[i]);
    }
    _free(pkt);
    RETVAL = fingerprint_str;
#line 4865 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM_verify_signature); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_verify_signature)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "filename, prefix=NULL");
    {
	char *	filename = (char *)SvPV_nolen(ST(0))
;
	char *	prefix;
#line 3237 "URPM.xs"
  rpmts ts = NULL;
  char result[1024];
  rpmRC rc;
  FD_t fd;
  Header h;
#line 4888 "URPM.c"
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    prefix = NULL;
	else {
	    prefix = (char *)SvPV_nolen(ST(1))
;
	}
#line 3243 "URPM.xs"
  fd = Fopen(filename, "r");
  if (fd == NULL)
    RETVAL = "NOT OK (could not read file)";
  else {
    read_config_files(0);
    ts = rpmtsCreate();
    rpmtsSetRootDir(ts, prefix);
    rpmtsOpenDB(ts, O_RDONLY);
    rpmtsSetVSFlags(ts, RPMVSF_DEFAULT);
    rc = rpmReadPackageFile(ts, fd, filename, &h);
    Fclose(fd);
    *result = '\0';
    switch(rc) {
      case RPMRC_OK:
	if (h) {
	  char *fmtsig = headerFormat(
	      h,
	      "%|DSAHEADER?{%{DSAHEADER:pgpsig}}:{%|RSAHEADER?{%{RSAHEADER:pgpsig}}:"
	      "{%|SIGGPG?{%{SIGGPG:pgpsig}}:{%|SIGPGP?{%{SIGPGP:pgpsig}}:{(none)}|}|}|}|",
	      NULL);
	  snprintf(result, sizeof(result), "OK (%s)", fmtsig);
	  free(fmtsig);
	} else snprintf(result, sizeof(result), "NOT OK (bad rpm): %s", rpmlogMessage());
	break;
      case RPMRC_NOTFOUND:
	snprintf(result, sizeof(result), "NOT OK (signature not found): %s", rpmlogMessage());
	break;
      case RPMRC_FAIL:
	snprintf(result, sizeof(result), "NOT OK (fail): %s", rpmlogMessage());
	break;
      case RPMRC_NOTTRUSTED:
	snprintf(result, sizeof(result), "NOT OK (key not trusted): %s", rpmlogMessage());
	break;
      case RPMRC_NOKEY:
	snprintf(result, sizeof(result), "NOT OK (no key): %s", rpmlogMessage());
	break;
    }
    RETVAL = result;
    if (h) headerFree(h);
    (void)rpmtsFree(ts);
  }

#line 4941 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM_import_pubkey_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_import_pubkey_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, filename");
    {
	URPM__DB	db;
	char *	filename = (char *)SvPV_nolen(ST(1))
;
#line 3294 "URPM.xs"
    const uint8_t *pkt = NULL;
    size_t pktlen = 0;
    int rc;
#line 4962 "URPM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "URPM::DB")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    db = INT2PTR(URPM__DB,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"URPM::import_pubkey_file",
			"db", "URPM::DB")
;
#line 3298 "URPM.xs"
    rpmts ts = rpmtsLink(db->ts);
    rpmtsClean(ts);

    if ((rc = pgpReadPkts(filename, (uint8_t ** ) &pkt, &pktlen)) <= 0)
        RETVAL = 0;
    else if (rc != PGPARMOR_PUBKEY)
        RETVAL = 0;
    else if (rpmtsImportPubkey(ts, pkt, pktlen) != RPMRC_OK)
        RETVAL = 0;
    else
        RETVAL = 1;
    _free(pkt);
    (void)rpmtsFree(ts);
#line 4989 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM_archscore); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_archscore)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "param");
    {
	const char *	param = (const char *)SvPV_nolen(ST(0))
;
#line 3320 "URPM.xs"
#line 5007 "URPM.c"
	int	RETVAL;
	dXSTARG;
#line 3321 "URPM.xs"
  read_config_files(0);
  RETVAL=rpmMachineScore(ix == 0 ? RPM_MACHTABLE_INSTARCH : RPM_MACHTABLE_INSTOS, param);
#line 5013 "URPM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM_stream2header); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_stream2header)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fp");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	FILE *	fp = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
#line 3331 "URPM.xs"
    FD_t fd;
    URPM__Package pkg;
#line 5034 "URPM.c"
#line 3334 "URPM.xs"
    if ((fd = fdDup(fileno(fp)))) {
        pkg = (URPM__Package)calloc(1, sizeof(struct s_Package));
        pkg->h = headerRead(fd, HEADER_MAGIC_YES);
        if (pkg->h)
            XPUSHs(sv_setref_pv(sv_newmortal(), "URPM::Package", (void*)pkg));
        else free(pkg);
        Fclose(fd);
    }
#line 5044 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM_spec2srcheader); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_spec2srcheader)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "specfile");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	specfile = (char *)SvPV_nolen(ST(0))
;
#line 3347 "URPM.xs"
    URPM__Package pkg;
    Spec spec = NULL;
    Header header = NULL;
#line 5066 "URPM.c"
#line 3351 "URPM.xs"
/* ensure the config is in memory with all macro */
  read_config_files(0);
/* Do not verify architecture */
/* Do not verify whether sources exist */
  spec = rpmSpecParse(specfile, RPMSPEC_ANYARCH|RPMSPEC_FORCE, NULL);
  if (spec) {
    header = rpmSpecSourceHeader(spec);
    pkg = (URPM__Package)calloc(1, sizeof(struct s_Package));
    pkg->h = headerLink(header);
    XPUSHs(sv_setref_pv(sv_newmortal(), "URPM::Package", (void*)pkg));
    rpmSpecFree(spec);
  } else {
    XPUSHs(&PL_sv_undef);
    /* apparently rpmlib sets errno to this when given a bad spec. */
    if (errno == EBADF)
      errno = 0;
  }
#line 5085 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM_expand); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_expand)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "name");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	name = (char *)SvPV_nolen(ST(0))
;
#line 3373 "URPM.xs"
    const char * value = rpmExpand(name, NULL);
    mXPUSHs(newSVpv(value, 0));
#line 5106 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM_add_macro_noexpand); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_add_macro_noexpand)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "macro");
    {
	char *	macro = (char *)SvPV_nolen(ST(0))
;
#line 3380 "URPM.xs"
    rpmDefineMacro(NULL, macro, RMIL_DEFAULT);
#line 5124 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_URPM_del_macro); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_del_macro)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "name");
    {
	char *	name = (char *)SvPV_nolen(ST(0))
;
#line 3386 "URPM.xs"
    delMacro(NULL, name);
#line 5141 "URPM.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_URPM_loadmacrosfile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_loadmacrosfile)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "filename");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	filename = (char *)SvPV_nolen(ST(0))
;
#line 3392 "URPM.xs"
    rpmInitMacros(NULL, filename);
#line 5160 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM_resetmacros); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_resetmacros)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 3397 "URPM.xs"
    rpmFreeMacros(NULL);
#line 5178 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM_setVerbosity); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_setVerbosity)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "level");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	level = (int)SvIV(ST(0))
;
#line 3403 "URPM.xs"
    rpmSetVerbosity(level);
#line 5198 "URPM.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_URPM_rpmErrorString); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_rpmErrorString)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	const char *	RETVAL;
	dXSTARG;
#line 3408 "URPM.xs"
  RETVAL = rpmlogMessage();
#line 5216 "URPM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_URPM_rpmErrorWriteTo); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_URPM_rpmErrorWriteTo)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
#line 3416 "URPM.xs"
  rpmError_callback_data = fd;
  rpmlogSetCallback(rpmError_callback, NULL);

  /* vim:set ts=8 sts=2 sw=2: */
#line 5237 "URPM.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_URPM); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_URPM)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("URPM::Package::DESTROY", XS_URPM__Package_DESTROY);
        cv = newXS_deffile("URPM::Package::arch", XS_URPM__Package_name);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("URPM::Package::name", XS_URPM__Package_name);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("URPM::Package::release", XS_URPM__Package_name);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("URPM::Package::version", XS_URPM__Package_name);
        XSANY.any_i32 = 1;
        newXS_deffile("URPM::Package::EVR", XS_URPM__Package_EVR);
        newXS_deffile("URPM::Package::is_arch_compat__XS", XS_URPM__Package_is_arch_compat__XS);
        newXS_deffile("URPM::Package::summary", XS_URPM__Package_summary);
        cv = newXS_deffile("URPM::Package::description", XS_URPM__Package_description);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("URPM::Package::packager", XS_URPM__Package_description);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("URPM::Package::buildhost", XS_URPM__Package_sourcerpm);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("URPM::Package::distribution", XS_URPM__Package_sourcerpm);
        XSANY.any_i32 = 4;
        cv = newXS_deffile("URPM::Package::license", XS_URPM__Package_sourcerpm);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("URPM::Package::os", XS_URPM__Package_sourcerpm);
        XSANY.any_i32 = 6;
        cv = newXS_deffile("URPM::Package::payload_format", XS_URPM__Package_sourcerpm);
        XSANY.any_i32 = 7;
        cv = newXS_deffile("URPM::Package::sourcerpm", XS_URPM__Package_sourcerpm);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("URPM::Package::url", XS_URPM__Package_sourcerpm);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("URPM::Package::vendor", XS_URPM__Package_sourcerpm);
        XSANY.any_i32 = 5;
        cv = newXS_deffile("URPM::Package::buildtime", XS_URPM__Package_buildtime);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("URPM::Package::installtid", XS_URPM__Package_buildtime);
        XSANY.any_i32 = 1;
        newXS_deffile("URPM::Package::fullname", XS_URPM__Package_fullname);
        newXS_deffile("URPM::Package::epoch", XS_URPM__Package_epoch);
        newXS_deffile("URPM::Package::compare_pkg", XS_URPM__Package_compare_pkg);
        newXS_deffile("URPM::Package::compare", XS_URPM__Package_compare);
        newXS_deffile("URPM::Package::size", XS_URPM__Package_size);
        newXS_deffile("URPM::Package::set_filesize", XS_URPM__Package_set_filesize);
        newXS_deffile("URPM::Package::filesize", XS_URPM__Package_filesize);
        newXS_deffile("URPM::Package::group", XS_URPM__Package_group);
        newXS_deffile("URPM::Package::filename", XS_URPM__Package_filename);
        newXS_deffile("URPM::Package::id", XS_URPM__Package_id);
        newXS_deffile("URPM::Package::set_id", XS_URPM__Package_set_id);
        cv = newXS_deffile("URPM::Package::conflicts", XS_URPM__Package_obsoletes);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("URPM::Package::obsoletes", XS_URPM__Package_obsoletes);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("URPM::Package::provides", XS_URPM__Package_obsoletes);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("URPM::Package::recommends", XS_URPM__Package_obsoletes);
        XSANY.any_i32 = 4;
        cv = newXS_deffile("URPM::Package::requires", XS_URPM__Package_obsoletes);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("URPM::Package::conflicts_nosense", XS_URPM__Package_obsoletes_nosense);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("URPM::Package::obsoletes_nosense", XS_URPM__Package_obsoletes_nosense);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("URPM::Package::provides_nosense", XS_URPM__Package_obsoletes_nosense);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("URPM::Package::recommends_nosense", XS_URPM__Package_obsoletes_nosense);
        XSANY.any_i32 = 4;
        cv = newXS_deffile("URPM::Package::requires_nosense", XS_URPM__Package_obsoletes_nosense);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("URPM::Package::suggests", XS_URPM__Package_obsoletes_nosense);
        XSANY.any_i32 = 4;
        cv = newXS_deffile("URPM::Package::obsoletes_overlap", XS_URPM__Package_obsoletes_overlap);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("URPM::Package::provides_overlap", XS_URPM__Package_obsoletes_overlap);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("URPM::Package::buildarchs", XS_URPM__Package_buildarchs);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("URPM::Package::changelog_name", XS_URPM__Package_buildarchs);
        XSANY.any_i32 = 8;
        cv = newXS_deffile("URPM::Package::changelog_text", XS_URPM__Package_buildarchs);
        XSANY.any_i32 = 9;
        cv = newXS_deffile("URPM::Package::dirnames", XS_URPM__Package_buildarchs);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("URPM::Package::excludearchs", XS_URPM__Package_buildarchs);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("URPM::Package::exclusivearchs", XS_URPM__Package_buildarchs);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("URPM::Package::filelinktos", XS_URPM__Package_buildarchs);
        XSANY.any_i32 = 4;
        cv = newXS_deffile("URPM::Package::files_group", XS_URPM__Package_buildarchs);
        XSANY.any_i32 = 7;
        cv = newXS_deffile("URPM::Package::files_md5sum", XS_URPM__Package_buildarchs);
        XSANY.any_i32 = 5;
        cv = newXS_deffile("URPM::Package::files_owner", XS_URPM__Package_buildarchs);
        XSANY.any_i32 = 6;
        cv = newXS_deffile("URPM::Package::conf_files", XS_URPM__Package_files);
        XSANY.any_i32 = FILTER_MODE_CONF_FILES;
        cv = newXS_deffile("URPM::Package::doc_files", XS_URPM__Package_files);
        XSANY.any_i32 = FILTER_MODE_DOC_FILES;
        cv = newXS_deffile("URPM::Package::files", XS_URPM__Package_files);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("URPM::Package::changelog_time", XS_URPM__Package_files_mtime);
        XSANY.any_i32 = 6;
        cv = newXS_deffile("URPM::Package::files_flags", XS_URPM__Package_files_mtime);
        XSANY.any_i32 = 5;
        cv = newXS_deffile("URPM::Package::files_gid", XS_URPM__Package_files_mtime);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("URPM::Package::files_mode", XS_URPM__Package_files_mtime);
        XSANY.any_i32 = 4;
        cv = newXS_deffile("URPM::Package::files_mtime", XS_URPM__Package_files_mtime);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("URPM::Package::files_size", XS_URPM__Package_files_mtime);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("URPM::Package::files_uid", XS_URPM__Package_files_mtime);
        XSANY.any_i32 = 2;
        newXS_deffile("URPM::Package::queryformat", XS_URPM__Package_queryformat);
        cv = newXS_deffile("URPM::Package::get_tag", XS_URPM__Package_get_tag);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("URPM::Package::get_tag_modifiers", XS_URPM__Package_get_tag);
        XSANY.any_i32 = 1;
        newXS_deffile("URPM::Package::pack_header", XS_URPM__Package_pack_header);
        newXS_deffile("URPM::Package::update_header", XS_URPM__Package_update_header);
        newXS_deffile("URPM::Package::free_header", XS_URPM__Package_free_header);
        newXS_deffile("URPM::Package::build_info", XS_URPM__Package_build_info);
        newXS_deffile("URPM::Package::build_header", XS_URPM__Package_build_header);
        newXS_deffile("URPM::Package::flag", XS_URPM__Package_flag);
        newXS_deffile("URPM::Package::set_flag", XS_URPM__Package_set_flag);
        cv = newXS_deffile("URPM::Package::set_flag_base", XS_URPM__Package_set_flag_skip);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("URPM::Package::set_flag_disable_obsolete", XS_URPM__Package_set_flag_skip);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("URPM::Package::set_flag_installed", XS_URPM__Package_set_flag_skip);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("URPM::Package::set_flag_requested", XS_URPM__Package_set_flag_skip);
        XSANY.any_i32 = 4;
        cv = newXS_deffile("URPM::Package::set_flag_required", XS_URPM__Package_set_flag_skip);
        XSANY.any_i32 = 5;
        cv = newXS_deffile("URPM::Package::set_flag_skip", XS_URPM__Package_set_flag_skip);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("URPM::Package::set_flag_upgrade", XS_URPM__Package_set_flag_skip);
        XSANY.any_i32 = 6;
        cv = newXS_deffile("URPM::Package::flag_base", XS_URPM__Package_flag_required);
        XSANY.any_i32 = 5;
        cv = newXS_deffile("URPM::Package::flag_disable_obsolete", XS_URPM__Package_flag_required);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("URPM::Package::flag_installed", XS_URPM__Package_flag_required);
        XSANY.any_i32 = 4;
        cv = newXS_deffile("URPM::Package::flag_requested", XS_URPM__Package_flag_required);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("URPM::Package::flag_required", XS_URPM__Package_flag_required);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("URPM::Package::flag_skip", XS_URPM__Package_flag_required);
        XSANY.any_i32 = 6;
        cv = newXS_deffile("URPM::Package::flag_upgrade", XS_URPM__Package_flag_required);
        XSANY.any_i32 = 1;
        newXS_deffile("URPM::Package::flag_selected", XS_URPM__Package_flag_selected);
        newXS_deffile("URPM::Package::flag_available", XS_URPM__Package_flag_available);
        newXS_deffile("URPM::Package::rate", XS_URPM__Package_rate);
        newXS_deffile("URPM::Package::set_rate", XS_URPM__Package_set_rate);
        newXS_deffile("URPM::Package::rflags", XS_URPM__Package_rflags);
        newXS_deffile("URPM::Package::set_rflags", XS_URPM__Package_set_rflags);
        newXS_deffile("URPM::DB::open", XS_URPM__DB_open);
        newXS_deffile("URPM::DB::rebuild", XS_URPM__DB_rebuild);
        newXS_deffile("URPM::DB::verify", XS_URPM__DB_verify);
        newXS_deffile("URPM::DB::DESTROY", XS_URPM__DB_DESTROY);
        newXS_deffile("URPM::DB::traverse", XS_URPM__DB_traverse);
        newXS_deffile("URPM::DB::traverse_tag", XS_URPM__DB_traverse_tag);
        newXS_deffile("URPM::DB::traverse_tag_find", XS_URPM__DB_traverse_tag_find);
        newXS_deffile("URPM::DB::create_transaction", XS_URPM__DB_create_transaction);
        newXS_deffile("URPM::Transaction::DESTROY", XS_URPM__Transaction_DESTROY);
        newXS_deffile("URPM::Transaction::set_script_fd", XS_URPM__Transaction_set_script_fd);
        newXS_deffile("URPM::Transaction::add", XS_URPM__Transaction_add);
#if XSubPPtmpAAAA
        newXS_deffile("URPM::Transaction::addReinstall", XS_URPM__Transaction_addReinstall);
#endif
        newXS_deffile("URPM::Transaction::remove", XS_URPM__Transaction_remove);
        newXS_deffile("URPM::Transaction::traverse", XS_URPM__Transaction_traverse);
        newXS_deffile("URPM::Transaction::check", XS_URPM__Transaction_check);
        newXS_deffile("URPM::Transaction::order", XS_URPM__Transaction_order);
        newXS_deffile("URPM::Transaction::NElements", XS_URPM__Transaction_NElements);
        cv = newXS_deffile("URPM::Transaction::Element_fullname", XS_URPM__Transaction_Element_name);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("URPM::Transaction::Element_name", XS_URPM__Transaction_Element_name);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("URPM::Transaction::Element_release", XS_URPM__Transaction_Element_name);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("URPM::Transaction::Element_version", XS_URPM__Transaction_Element_name);
        XSANY.any_i32 = 1;
        newXS_deffile("URPM::Transaction::run", XS_URPM__Transaction_run);
        newXS_deffile("URPM::bind_rpm_textdomain_codeset", XS_URPM_bind_rpm_textdomain_codeset);
        newXS_deffile("URPM::read_config_files", XS_URPM_read_config_files);
        newXS_deffile("URPM::rpmvercmp", XS_URPM_rpmvercmp);
        newXS_deffile("URPM::ranges_overlap", XS_URPM_ranges_overlap);
        newXS_deffile("URPM::parse_synthesis__XS", XS_URPM_parse_synthesis__XS);
        newXS_deffile("URPM::parse_hdlist__XS", XS_URPM_parse_hdlist__XS);
        newXS_deffile("URPM::parse_rpm", XS_URPM_parse_rpm);
        newXS_deffile("URPM::verify_rpm", XS_URPM_verify_rpm);
        newXS_deffile("URPM::get_gpg_fingerprint", XS_URPM_get_gpg_fingerprint);
        newXS_deffile("URPM::verify_signature", XS_URPM_verify_signature);
        newXS_deffile("URPM::import_pubkey_file", XS_URPM_import_pubkey_file);
        cv = newXS_deffile("URPM::archscore", XS_URPM_archscore);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("URPM::osscore", XS_URPM_archscore);
        XSANY.any_i32 = 1;
        newXS_deffile("URPM::stream2header", XS_URPM_stream2header);
        newXS_deffile("URPM::spec2srcheader", XS_URPM_spec2srcheader);
        newXS_deffile("URPM::expand", XS_URPM_expand);
        newXS_deffile("URPM::add_macro_noexpand", XS_URPM_add_macro_noexpand);
        newXS_deffile("URPM::del_macro", XS_URPM_del_macro);
        newXS_deffile("URPM::loadmacrosfile", XS_URPM_loadmacrosfile);
        newXS_deffile("URPM::resetmacros", XS_URPM_resetmacros);
        newXS_deffile("URPM::setVerbosity", XS_URPM_setVerbosity);
        newXS_deffile("URPM::rpmErrorString", XS_URPM_rpmErrorString);
        newXS_deffile("URPM::rpmErrorWriteTo", XS_URPM_rpmErrorWriteTo);

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#line 2870 "URPM.xs"
(void) read_config_files(0);

#line 5490 "URPM.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

